      program clus
C     B.P. van Eijck, March 1996.
C     This program removes identical solutions from PACK-files.
C     For every triclinic, monoclinic or orthorhombic space group.
C     Further input: file IN.SPG (see subroutine LEESR) and IN.CLU.
C     Uses subroutines DIFF (which uses TRANSF), LEESR, and SORT.

C     Input from keyboard: IFS
C          IFS<2: read all files PACK.001, PACK.002, ....
C                 write to files PACK.101, PACK.102, ....
C          IFS>1: read the file PACK.IFS
C                 write to file PACK.(IFS+1)

C     Input from tape IN.CLU: see manual.

C     Output: clustered PACK-file on unit 20 (see IFS)
C             text file OUT.PRI and (if IPRINT>1) more elaborate: FORT.75.

      implicit none
      include 'params.i'
      include 'cspgr.i'
      include 'color.i'
      integer i,i1,i2,i3,i4,icode,idata,idih,ierr,ifil,iform,ifs,imain,
     +     inblok,indx,inner,inpt,ios,ipre,iprint,iref,irefin,irefr,
     +     irot,iscr,iscrfl,isort,ispgr,istart,isym,itest,iweg,
     +     j,jdata,jmin,jref,jtest,jweg,k,m,m123,maxinp,msom,msym,
     +     mxblok,n,n1,n2,nblok,ndata,ndih,ndiha,ndihh,ninp,nleft,
     +     npar,nr,nrot,nrp,nsym,ntot,nw,nweg,nword
      double precision a,a1r1m,abox,ainv,auinv,box,box1,box2,c,ca,cb,
     +     cel,cg,costh,d,dat,der,difa,difb,dih,dmax,drot,emin,en,
     +     enj,enr,euler,phi,pi,psi,r2a2,rad,rot1,rot2,sa,sb,scr,sg,
     +     the,theta,tolb,tolh,toln,tolz,wrot


      parameter(mxblok=500)
      dimension der(12),scr(3),cel(12),iscr(12),
     +     box(12),box1(12),box2(12),iref(12),irefin(12),
     +     rot1(3,3),rot2(3,3),euler(3,3),wrot(3,3),
     +     msym(0:8,3),m123(0:8),msom(3),nweg(mxdata),
     +     en(mxdata),idata(mxdata,2),enj(mxblok),jdata(mxblok,2),
     +     dmax(maxome+12),dih(maxome),iweg(mxdata),indx(mxdata),
     +     jweg(mxblok)
      integer*2 itau(mxdata,maxome),ipar(mxdata,12),
     +     jtau(mxblok,maxome),jpar(mxblok,12)

      dimension auinv(3,3,mxdata),
     +     dat(12,mxdata),abox(3,3),ainv(3,3),a1r1m(3,3),r2a2(3,3)

      character file1*9,file2*9,regel*200,form20*60
      character*8 panm,spname

      open(unit=16,file='out.pri')
      open(unit=13,file='in.clu',status='OLD',iostat=ios)
      print*,geel,' C L U S T E R I N G',wit
      write(16,*) ' '
      write(16,*) ' C L U S T E R I N G'
      if (ios.ne.0) then
         print*,'No file IN.CLU present'
         write(16,*) 'No file IN.CLU present'
      else
         regel=' '
         n=inpt('INPUT ',regel)
         close(13)
      endif
      pi=4*atan(1.0d0)
      rad=180/pi
      m123(0)=1
      idih=0
      do i=1,3
         msym(0,i)=1
      enddo
      nrot=1
      nsym=0
      isort=1
      ipre=0
      imain=1
      n1=1
      n2=100000
      maxinp=50000
      nblok=100000
      iprint=0
      toln=0.20d0
      tolb=0.05d0
      tolz=10
      tolh=30
      der(1)=0.10d0
      der(2)=0.08d0
      der(3)=0.08d0
      der(4)=5
      iform=0
      iscrfl=0

      print*,' Specify input file (0, 1 of file number) '
      read*, ifs
      n=inpt('PRE   ',regel)
      if (n.ge.1) ipre=1
      if (n.ge.5) then
         call realst(regel,2,der(1))
         call realst(regel,3,der(2))
         call realst(regel,4,der(3))
         call realst(regel,5,der(4))
      endif
      n=inpt('TOL   ',regel)
      if (n.ge.5) then
         call realst(regel,2,toln)
         call realst(regel,3,tolb)
         call realst(regel,4,tolz)
         call realst(regel,5,tolh)
      endif
      n=inpt('SCR   ',regel)
      if (n.ge.1) then
         call intstr(regel,2,iscrfl)
      endif
      n=inpt('FORM  ',regel)
      if (n.ge.1) then
         call intstr(regel,2,iform)
      endif
C     Scratch files formatted: iform=1; unformatted: iform=0
      n=inpt('SYM   ',regel)
      if (n.ge.2) then
         call intstr(regel,2,nrot)
         nsym=(n-2)/3
         if (3*nsym.ne.n-2) then
            print*,' ***** Wrong number of data for NSYM',n,nsym
            stop
         endif
         do i=1,nsym
            call intstr(regel,3*i,msym(i,1))
            call intstr(regel,3*i+1,msym(i,2))
            call intstr(regel,3*i+2,msym(i,3))
            m123(i)=msym(i,1)*msym(i,2)*msym(i,3)
         enddo
      endif
      n=inpt('SORT  ',regel)
      if (n.ge.2) call intstr(regel,2,isort)
      n=inpt('MAIN  ',regel)
      if (n.ge.2) call intstr(regel,2,imain)
      n=inpt('MAXINP',regel)
      if (n.ge.2) call intstr(regel,2,maxinp)
      if (maxinp.gt.mxdata) then
         print*,' ***** MAXINP too large',maxinp,mxdata
         stop
      endif
      n=inpt('SEL   ',regel)
      if (n.ge.3) then
         call intstr(regel,2,n1)
         call intstr(regel,3,n2)
      endif
      n=inpt('PRINT ',regel)
      if (n.ge.2) call intstr(regel,2,iprint)
      n=inpt('BLOCK ',regel)
      if (n.ge.2) call intstr(regel,2,nblok)
      if (nblok.gt.mxdata) then
         print*,' ***** NBLOK too large',nblok,mxdata
         stop
      endif

      print 21,ifs
      print 22,(der(i),i=1,4),toln,tolb,tolh,tolz
      write(16,21) ifs
      write(16,22) (der(i),i=1,4),toln,tolb,tolh,tolz
      if (nrot.gt.1) print*,' nrot =',nrot
      if (nsym.gt.0) then
         print*,' Symmetry codes:'
         write(16,*) ' Symmetry codes:'
         do i=1,nsym
            print 94, (msym(i,j),j=1,3)
            write(16,94) (msym(i,j),j=1,3)
         enddo
      endif
      print 23,isort,ipre,imain
      print 24,n1,n2,maxinp,nblok,iprint
      write(16,23) isort,ipre,imain
      write(16,24) n1,n2,maxinp,nblok,iprint
      close(12)
      der(4)=der(4)/rad
      drot=2*pi/nrot
      ndata=n2-n1+1
      nleft=ndata

C     If IFS > 1: open file IFS and initialize file IFS+1
      if (ifs.gt.1) then
         write(file1,16) 'pack.',ifs
         write(file2,16) 'pack.',ifs+1
         open(unit=10,file=file1,status='OLD',err=970)
         open(unit=20,file=file2)
         read(10,13) regel
         spname='noname'
         call intstr(regel,1,ispgr)
         icode=0
         if (nword(regel).gt.1) call intstr(regel,2,icode)
         read(10,*) ndih,ndihh
         write(20,94) ispgr,icode
         write(20,94) ndih,ndihh
         ndiha=ndih+ndihh
         if (icode.eq.0) goto 220
         do i=1,ndiha
            read(10,*) i1,i2,i3,i4
            write(20,87) i1,i2,i3,i4
         enddo
         read(10,13) regel
         write(20,13) regel
         call intstr(regel,1,nrp)
         do i=1,nrp
            read(10,72) k,panm(1:5),j,(scr(m),m=1,3)
            write(20,72) k,panm(1:5),j,(scr(m),m=1,3)
         enddo
         goto 220
      endif

 200  idih=idih+1
C     If IFS=0,1: open the next file of the series PACK.001, PACK.002,...
C       and initialize the next file of the series PACK.101, PACK.102,...
      write(file1,15) 'pack.',idih
      write(file2,15) 'pack.',idih+100
      open(unit=10,file=file1,status='OLD',err=980)
      open(unit=20,file=file2)
      read(10,13) regel
      call intstr(regel,1,ispgr)
      icode=0
      if (nword(regel).gt.1) call intstr(regel,2,icode)
      write(20,94) ispgr,icode
      if (icode.eq.0) then
         read(10,*) ndih,(dih(i),i=1,ndih)
         write(20,94) ndih,0
         do i=1,ndih
            read(10,*) i1,i2,i3,i4
            write(20,87) i1,i2,i3,i4,dih(i)
         enddo
         goto 207
      endif
      read(10,*) ndih,ndihh
      write(20,94) ndih,ndihh
      do i=1,ndih
         read(10,*) i1,i2,i3,i4,dih(i)
         write(20,87) i1,i2,i3,i4,dih(i)
      enddo
 207  continue
      read(10,13) regel
      write(20,13) regel
      call intstr(regel,1,nrp)
      do i=1,nrp
         read(10,72) k,panm(1:5),j,(scr(m),m=1,3)
         write(20,72) k,panm(1:5),j,(scr(m),m=1,3)
      enddo
      ndiha=0
      ndihh=0

 220  continue
      read(10,93) (cel(i),i=1,12)
      read(10,94) (irefin(i),i=1,12)
      write(20,93) (cel(i),i=1,12)
      write(20,94) (irefin(i),i=1,12)
      ntot=0

      if (idih.gt.1) goto 270
C     Read space group data, initialize
      call leesr(ispgr,spname,iref,iscr,msom,inner)
      do i=1,12
         if (iref(i).ne.irefin(i)) then
            print*,' iref',i,' inconsistent:',iref(i),irefin(i)
            print*,' ******* CLUSTERING UNRELIABLE !!'
         endif
      enddo
      print 94,(iref(i),i=1,12)
      write(16,*) ' Refined parameters:'
      write(16,94) (iref(i),i=1,12)
      write(16,*) ' Starting values:'
      write(16,93) (cel(i),i=1,12)
      npar=0
      do i=1,12
         if (iref(i).gt.0) then
            npar=npar+1
            dmax(npar)=1000*der((i+2)/3)
            if (i.gt.9) then
               dmax(npar)=dmax(npar)*rad/100
            endif
         endif
      enddo
      write(form20,17) npar+ndiha
      if (ifs.gt.1) then
         do m=1,ndih
            dmax(npar+m)=tolz
         enddo
         do m=1,ndihh
            dmax(npar+ndih+m)=tolh
         enddo
         print*, ' Numbers of parameters ',npar,ndih,ndihh
         write(16,*) ' Numbers of parameters ',npar,ndih,ndihh
         write(16,*) ' Allowed tolerances:'
         write(16,93) (dmax(m)/1000,m=1,npar)
         write(16,93) (dmax(npar+m),m=1,ndiha)
      else
         print*, ' Number of parameters ',npar
         write(16,*) ' Number of parameters ',npar
         write(16,*) ' Allowed tolerances:'
         write(16,93) (dmax(m)/1000,m=1,npar)
      endif

C     If the scratch files are already prepared, read them up to the
C     file numbered ISCRFL and start clustering
      if (iscrfl.gt.0) then
         ifil=iscrfl
         ntot=maxinp
         goto 560
      endif

 270  continue
C     Select outputfile: if NDATA > NBLOK use temporary files fort.21,22,...
      ifil=20
c      do i=1,mxdata
c         nweg(i)=1
c      enddo
      inblok=ndata
      print*,file1,'  ',file2
      write(16,*) file1,'  ',file2
      if (ndata.gt.nblok) then
         print*,'Data treated in several parts'
         write(16,*) 'Data treated in several parts'
         inblok=nblok
         ifil=21
         print 82,ifil,ifil-20
         write(16,82) ifil,ifil-20
      endif
C     Start reading input structures (perhaps skipping some first)
      ninp=1
      do i=1,n1-1
         read(10,14,end=990,err=990) regel
      enddo
 300  continue
C     Read new line from input file
c      read(10,99,iostat=ios)
c     +     (idata(ninp,m),m=1,2),en(ninp),(ipar(ninp,m),m=1,npar),
c     +     (itau(ninp,m),m=1,ndiha)
      read(10,14,iostat=ios) regel
      if (ios.lt.0) then
         print*,'End-of-file reached'
         write(16,*) 'End-of-file reached'
         goto 310
      endif
      if (ios.gt.0) then
         write(16,*) ' ***** Error reading data',ninp
         print*,' ***** Error reading data',ninp
         goto 300
      endif
      read(regel,*)
     +     (idata(ninp,m),m=1,2),en(ninp),(ipar(ninp,m),m=1,npar),
     +     (itau(ninp,m),m=1,ndiha)
      if (ifs.le.20) then
C        No multiplicities after PACK1 or PACK2
         nweg(ninp)=1
      else
C        Multiplicity is the last entry on the line
         n=nword(regel)
         call intstr(regel,n,nweg(ninp))
      endif
      do m=1,3
         if (ipar(ninp,m).lt.2) then
            write(16,*) ' ***** Error reading data',ninp,m,ipar(ninp,m)
            print*,' ***** Error reading data',ninp,m,ipar(ninp,m)
            goto 300
         endif
      enddo
      if (iprint.gt.8)
     +     print*,' new line read: ',(ipar(ninp,m),m=1,npar),
     +     (itau(ninp,m),m=1,ndiha)
      ninp=ninp+1
      if (ninp.le.inblok) goto 300
      if (ifil.eq.20) then
         print*,'***** End-of-file not reached'
         write(16,*) '***** End-of-file not reached'
      endif

 310  continue
      ninp=ninp-1
      print*,ninp,' data read'
      write(16,*) ninp,' data read'
      if (ninp.eq.0) goto 550

      do irefr=1,ninp
         if (ifs.lt.2) then
            do i=1,ndih
               itau(irefr,i)=nint(dih(i))
            enddo
         endif
         k=0
         do i=1,12
            if (iref(i).gt.0) then
               k=k+1
               box(i)=dfloat(ipar(irefr,k))/1000
            else
               box(i)=cel(i)
            endif
         enddo
         do i=1,12
            dat(i,irefr)=box(i)
         enddo
         abox(1,1)=box(1)
         abox(1,2)=0
         abox(1,3)=0
         abox(2,1)=box(4)
         abox(2,2)=box(2)
         abox(2,3)=0
         abox(3,1)=box(5)
         abox(3,2)=box(6)
         abox(3,3)=box(3)
         phi=box(10)*100/rad
         the=box(11)*100/rad
         psi=box(12)*100/rad
         ca=cos(phi)
         sa=sin(phi)
         cb=cos(the)
         sb=sin(the)
         cg=cos(psi)
         sg=sin(psi)
         rot2(1,1)= cg*ca-sg*sa*cb
         rot2(1,2)= cg*sa+sg*ca*cb
         rot2(1,3)= sg*sb
         rot2(2,1)=-sg*ca-cg*sa*cb
         rot2(2,2)=-sg*sa+cg*ca*cb
         rot2(2,3)= cg*sb
         rot2(3,1)= sa*sb
         rot2(3,2)=-ca*sb
         rot2(3,3)= cb
         do i=1,3
            do j=1,3
               a=0
               do k=1,3
                  a=a+rot2(k,i)*abox(j,k)
               enddo
               auinv(i,j,irefr)=a
            enddo
         enddo
C        This is R2(transp).A2
         iweg(irefr)=0
         indx(irefr)=irefr
      enddo

C     Sort data
      if (ninp.lt.2) goto 520
      if (isort.eq.1) then
         call sort(ninp,en,indx)
         write(16,*) ninp,' data sorted'
         print*,ninp,' data sorted'
      endif
      if (ndata.le.nblok .and. ninp.gt.maxinp) ninp=maxinp
      print*,ninp,' data used'
      write(16,*) ninp,' data used'

      if (ipre.ne.1) goto 400
C     Do preselection. Remove a structure only if all parameters are the same.
C     If a structure is removed, IWEG gives the equivalent structure.
C     NWEG gives the number of times a structure is removed against JREF
      do irefr=1,ninp
         jref=indx(irefr)
         if (iweg(jref).ne.0) goto 350
         do itest=irefr+1,ninp
            jtest=indx(itest)
            if (iweg(jtest).ne.0) goto 340
            do m=1,npar
               d=abs(ipar(jref,m)-ipar(jtest,m))
               if (d.gt.dmax(m)) goto 340
            enddo
            do m=1,ndiha
               d=abs(itau(jref,m)-itau(jtest,m))
c               print*,irefr,jref,itest,jtest,itau(irefr,m),itau(itest,m)
               if (d.gt.180) d=d-360
               if (abs(d).gt.dmax(m+npar)) goto 340
            enddo
            iweg(jtest)=idata(jref,2)
 340        continue
         enddo
 350     continue
      enddo
      n=0
      do i=1,ninp
         j=indx(i)
         if (iweg(j).eq.0) then
            n=n+1
            if (iprint.gt.3) print 99,
     +           i,idata(j,2),en(j),(ipar(j,m),m=1,npar),
     +           (itau(j,m),m=1,ndiha)
         endif
      enddo
      write(16,*) n, ' structures left after pre-selection'
      print*,n,' structures left after pre-selection'

 400  continue
      if (ifil.eq.20 .and. imain.eq.0) goto 520
      if (ifil.gt.20 .and. imain.ne.2) goto 520
C     Do main selection. First do the reference structures:
      do irefr=1,ninp
         jref=indx(irefr)
         nw=1
         if (iweg(jref).ne.0) goto 510
         if (iprint.gt.1) print 98,geel,irefr,idata(jref,2),wit,
     +        en(jref),(ipar(jref,m),m=1,npar),(itau(jref,m),m=1,ndiha)
         do i=1,12
            box1(i)=dat(i,jref)
         enddo
         do irot=1,nrot
            phi=box1(10)*100/rad+irot*drot
            the=box1(11)*100/rad
            psi=box1(12)*100/rad
            ca=cos(phi)
            sa=sin(phi)
            cb=cos(the)
            sb=sin(the)
            cg=cos(psi)
            sg=sin(psi)
            rot1(1,1)= cg*ca-sg*sa*cb
            rot1(1,2)= cg*sa+sg*ca*cb
            rot1(1,3)= sg*sb
            rot1(2,1)=-sg*ca-cg*sa*cb
            rot1(2,2)=-sg*sa+cg*ca*cb
            rot1(2,3)= cg*sb
            rot1(3,1)= sa*sb
            rot1(3,2)=-ca*sb
            rot1(3,3)= cb
            call invbox(box1,ainv)
            do isym=0,nsym
               if (iprint.gt.2) print 89,irot,isym,
     +              m123(isym),(msym(isym,j),j=1,3)
               do i=1,3
                  do j=1,3
                     c=m123(isym)*msym(isym,j)
                     a1r1m(i,j)=0
                     do k=1,3
                        a1r1m(i,j)=a1r1m(i,j)+ainv(k,i)*rot1(k,j)*c
                     enddo
C                    This is +/- A1(inv).R1.M
                  enddo
               enddo
c               box1(7)=box1(7)*m123(isym)
c               box1(8)=box1(8)*m123(isym)
c               box1(9)=box1(9)*m123(isym)
               box1(7)=dat(7,jref)*m123(isym)
               box1(8)=dat(8,jref)*m123(isym)
               box1(9)=dat(9,jref)*m123(isym)

C              Now do the test structures:
               istart=irefr+1
               do itest=istart,ninp
                  jtest=indx(itest)
                  if (iweg(jtest).ne.0) goto 500
C                 Structures cannot be equivalent if the dihedrals differ
                  do i=1,ndiha
                     d=abs(itau(jtest,i)-itau(jref,i))
                     if (d.gt.180) d=d-360
                     if (abs(d).gt.dmax(npar+i)) then
                        if (iprint.gt.5)
     +                       print*,i,itau(jtest,i),itau(jref,i)
                        goto 500
                     endif
                  enddo

C                 Do the main test
                  do i=1,9
                     box2(i)=dat(i,jtest)
                  enddo
                  do i=1,3
                     do j=1,3
                        r2a2(i,j)=auinv(i,j,jtest)
                     enddo
                  enddo
C                 This is R2(transp).A2

                  if (iprint.gt.3) then
                     print 33, (box1(m),m=1,9)
                     print 33, (box2(m),m=1,9)
                     print 33, ((a1r1m(m,n),m=1,3),n=1,3)
                     print 33, ((r2a2(m,n),m=1,3),n=1,3)
                  endif
                  call diff(box1,box2,a1r1m,r2a2,iref,toln,iprint,
     +                 ierr,difa,difb,box,wrot)
                  nr=idata(jtest,2)
                  if (ierr.eq.1) then
                     if (iprint.gt.3) print 92,nr
                     goto 480
                  endif
                  if (ierr.gt.1) then
                     if (iprint.gt.2) print 91,nr,ierr
                     goto 480
                  endif

C                 Check whether differences are acceptable
                  if (difb.gt.tolb) then
                     if (iprint.gt.2) print 95,nr,difa,difb,' too large'
                     goto 480
                  endif
                  iweg(jtest)=idata(jref,2)
                  nw=nw+1
                  nweg(jref)=nweg(jref)+nweg(jtest)
c                  print*, 'removed',jtest,nweg(jtest)
                  if (iprint.gt.1) print 95,nr,difa,difb,' acceptable'
                  if (iprint.gt.2) print 97,en(jtest),
     +                 (ipar(jtest,m),m=1,npar),
     +                 (itau(jtest,m),m=1,ndiha)
                  if (iprint.gt.2) then
C                    Investigate possible transformation
                     call matmat(euler,wrot,rot1)
                     costh=euler(3,3)
                     if (abs(costh).gt.1) costh=sign(1.0d0,costh)
                     theta=acos(costh)
                     if (abs(costh).le.0.99999) then
                        psi=atan2(euler(1,3),euler(2,3))
                        phi=atan2(euler(3,1),-euler(3,2))
                     else
                        phi=0
                        psi=atan2(euler(1,2)*costh,euler(2,2)*costh)
C                       This is arbitrary, only (PHI + PSI) is determinable
                     endif
                     if (phi.lt.-0.1) phi=phi+2*pi
                     if (psi.lt.-0.1) psi=psi+2*pi
                     box(10)=phi*rad/100
                     box(11)=theta*rad/100
                     box(12)=psi*rad/100
                     k=0
                     do i=1,12
                        if (iref(i).gt.0) then
                           k=k+1
                           iscr(k)=nint(box(i)*1000)
                        endif
                     enddo
                     print 96,(iscr(m),m=1,k)
                  endif
 480              continue
 500              continue
               enddo
            enddo
         enddo
         if (iprint.gt.0 .and. nw.gt.1) print 88,irefr,nw,nweg(jref)
 510     continue
      enddo

 520  n=0
      nw=0
      do i=1,ninp
         j=indx(i)
         if (iweg(j).eq.0) then
            n=n+1
            nw=nw+nweg(j)
            if (iprint.gt.1) print form20,(idata(j,m),m=1,2),en(j),
     +           (ipar(j,m),m=1,npar),(itau(j,m),m=1,ndiha),nweg(j)
            if (ifil.eq.20) then
               if (ifs.eq.20) then
C                 Set multiplicity to 1 for use witk PACK3
                  write(20,form20) n,idata(j,2),en(j),
     +                 (ipar(j,m),m=1,npar),(itau(j,m),m=1,ndiha),
     +                 nweg(j),1
               else
C                 Propagate multiplicity to next calculations
                  write(20,form20) n,idata(j,2),en(j),
     +                 (ipar(j,m),m=1,npar),(itau(j,m),m=1,ndiha),
     +                 nweg(j)
               endif
            else
               if (iform.eq.1) write(ifil,99) n,idata(j,2),
     +              en(j),(ipar(j,m),m=1,npar),(itau(j,m),m=1,ndiha),
     +              nweg(j)
               if (iform.eq.0) write(ifil) n,idata(j,2),
     +              en(j),(ipar(j,m),m=1,npar),(itau(j,m),m=1,ndiha),
     +              nweg(j)
            endif
         endif
         if (iprint.gt.1) then
            if (iweg(j).eq.0) then
               write(75,99) n,idata(j,2),en(j),
     +              (ipar(j,m),m=1,npar),(itau(j,m),m=1,ndiha)
            else
               write(75,90) idata(j,2),en(j),iweg(j)
            endif
         endif
      enddo
      if (iprint.gt.0) then
         print*,' '
         print*,ninp,' data read'
         if (isort.eq.1) print*,ninp,' data sorted'
         print*,ninp,' data used'
      endif
c      write(16,*) nw, ' data kept, including multiplicities'
c      print*,nw,' data kept, including multiplicities'
      write(16,*) n,' left after clustering'
      print*,n,' left after clustering'
      if (iprint.gt.0) print*,' '
      nleft=nleft-ninp
      ntot=ntot+n

      close(ifil)
C     Check whether this file is done
      if (ios.ge.0 .and. ifil.ne.20 .and. nleft.gt.0) then
         inblok=nleft
         if (nleft.gt.nblok) then
            inblok=nblok
         endif
         ifil=ifil+1
         print 82,ifil,ifil-20
         write(16,82) ifil,ifil-20
         ninp=1
         if (ifil.gt.20+mxblok) then
            print*,' ***** Increase mxblok'
            stop
         endif
c         do i=1,mxdata
c            nweg(i)=1
c         enddo
         goto 300
      endif
 550  continue
      close(10)

 560  continue

      if (ifil.ne.20) then
C        Read first line from scratch files
         irefr=0
         print 83, ntot,ifil-20
         write(16,83) ntot,ifil-20
         do i=21,ifil
            j=i-20
            enj(j)=1.0d29
            if (iform.eq.1) read(i,99,end=570,err=570) (jdata(j,m),
     +           m=1,2),enr,(jpar(j,m),m=1,npar),(jtau(j,m),m=1,ndiha),
     +           jweg(j)
            if (iform.eq.0) read(i,end=570,err=570) (jdata(j,m),
     +           m=1,2),enr,(jpar(j,m),m=1,npar),(jtau(j,m),m=1,ndiha),
     +           jweg(j)
            if (iprint.gt.3)
     +           print form20, (jdata(j,m),m=1,2),enr,
     +           (jpar(j,m),m=1,npar),(jtau(j,m),m=1,ndiha),jweg(j)
            enj(j)=enr
            goto 580
 570        continue
            print*,' ***** Error reading file', i
c           Probably this file is empty.
c           Or maybe too many files are opened? Then try increasing NBLOK
 580        continue
         enddo
 590     continue
C        Select lowest energy, read next line from that scratch file
         emin=1.0d30
         do j=1,ifil-20
            if (enj(j).lt.emin) then
               emin=enj(j)
               jmin=j
            endif
         enddo
         if (emin.lt.1.0d28 .and. irefr.lt.maxinp) then
            irefr=irefr+1
c            print*,' Selected',irefr,jmin,enj(jmin)
            en(irefr)=emin
            idata(irefr,1)=jdata(jmin,1)
            idata(irefr,2)=jdata(jmin,2)
            do m=1,npar
               ipar(irefr,m)=jpar(jmin,m)
            enddo
            do m=1,ndiha
               itau(irefr,m)=jtau(jmin,m)
            enddo
            nweg(irefr)=jweg(jmin)
            if (iform.eq.1) read(jmin+20,99,end=650,err=650)
     +           (jdata(jmin,m),m=1,2),enj(jmin),
     +           (jpar(jmin,m),m=1,npar),(jtau(jmin,m),m=1,ndiha),
     +           jweg(jmin)
            if (iform.eq.0) read(jmin+20,end=650,err=650)
     +           (jdata(jmin,m),m=1,2),enj(jmin),
     +           (jpar(jmin,m),m=1,npar),(jtau(jmin,m),m=1,ndiha),
     +           jweg(jmin)
         else
c            print*,(enj(j),j=1,ifil-20)
            print 84, irefr,ifil-20,ifil
            write(16,84) irefr,ifil-20,ifil
            if (irefr.ne.ntot) then
               print*,' ***** This is inconsistent with NTOT',ntot
               write(16,*) ' ***** This is inconsistent with NTOT:',ntot
            endif
            ninp=irefr+1
            do i=21,ifil
               close(i)
            enddo
            ifil=20
            print*,'Now start final clustering'
            write(16,*) 'Now start final clustering'
            goto 310
         endif
         goto 590
 650     continue
         print*,' end of scratch file', jmin+20,enj(jmin)
         enj(jmin)=1.0d29
         goto 590
      endif
      if (ifs.gt.1) then
         i=inpt('CHECK ',regel)
         stop
      endif
C     Do the next dihedral
      goto 200

 970  print*,' ***** No input PACK file present'
      stop
 980  print*,' No further PACK-files present'
      i=inpt('CHECK ',regel)
      stop
 990  print*,' ***** Insufficient data'
      stop

c 10   format(i5,f10.3)
 13   format(a80)
 14   format(a)
 15   format(a5,i3.3)
 16   format(a5,i2.2)
 17   format('(2i7,f8.1,1x,',i2,'i5,i7,10i5)')
 21   format(' Input file:',i4)
 22   format(' Tolerances:',4f8.4,6x,2f8.4,2f8.1)
 23   format(' isort, ipre,imain:',3i4)
 24   format(' n1,n2,maxinp,nblok,iprint:',4i12,i4)
c 30   format(10f7.3)
 33   format(12f10.5)
 72   format(i5,5x,a5,i5,6f8.4)
 82   format(6x,'Creating file', i6,' for section',i6)
 83   format(6x,'Retrieving',i9,' structures from',i5,' files')
 84   format(i9,' structures recovered from',i6,
     +     ' files, the last file being',i6)
 87   format(4i5,f10.3)
 88   format(5x,'Reference',i7,' retained in a clustered group of',
     +     i5,' with total',3i5)
 89   format(13x,'Rotation',i3,4x,'Symmetry operation',i5,i8,4x,3i4)
 90   format(i14,f8.1,' equivalent to ',i7)
 91   format(18x,'Test ',i8,4x,
     +     '    No transformation possible, error condition',i4)
 92   format(18x,'Test ',i8,4x,
     +     '    No integer transformation matrix')
 93   format(6f10.4)
 94   format(12i5)
 95   format(18x,'Test ',i8,8x,'Deviations',2f8.4,a15)
 96   format(39x,'After transformation:',6x,25i5)
 97   format(39x,'Equivalent: ',f10.1,1x,25i5)
 98   format(a,i6,'   Reference :    ',i7,a,13x,f10.1,1x,25i5)
 99   format(2i7,f8.1,1x,25i5)
      end
