      subroutine dens(nrp,amass,vest)
C     B. P. van Eijck, July 2002. Estimate crystal density,
C     following Hoffmann, Acta Cryst. B58 (2002) 489 (or 20 A3 per atom)

      implicit none
      integer i,m,nrp
      double precision amass,vest,vlist
      dimension amass(*), vlist(1:300)
      do i=1,300
         vlist(i)=-1
      enddo
      vlist(1) = 5.08d0
      vlist(12)=13.87d0
      vlist(14)=11.8d0
      vlist(16)=11.39d0
      vlist(19)=11.17d0
      vlist(35)=25.8d0
      vlist(80)=32.7d0
      vlist(127)=46.2d0
      do i=1,nrp
         m=nint(amass(i))
         if (vlist(m).lt.0) then
            print*,' ***** Include mass ',m,' in table in YDENS'
            vest=vest+20
         else
            vest=vest+vlist(m)
         endif
      enddo
C     Thermal expansion and nanometer units:
      vest=1.03d0*vest/1000
      end
