      program dist

C     This program clusters structures on the basis of a distance criterion.
C     Written bij W.T.M. Mooij, adapted by B.P. van Eijck.
C     See the manual for description.

C     Coordinates are input via unit 101 (102, 103, .....)
C     and structures to be investigated via unit 201 (202, 203, .....)
C     Unsorted output via unit 301 (302, 303, .....)
C     Output of common structures via file MULTIPLES if card MULT is present.

C     Uses subroutines DLIST, DCLUS, LEESS, EXPSYM, LTW, TRI, SORT, LEESC.

      implicit none

      include 'cdist.i'
      include 'color.i'
      integer i,i1,i2,icode,icorf,icount,idum,iendln,ientr,
     +     ierr,ifil,ifiles,ihit,ii,imp,import,impr,inbuf,incor,indbuf,
     +     indeze,infile,inl,inlist,inpar,inparp,inpt,inspf,intot,intra,
     +     inttot,ios,iosc,iosp,iospl,ioutf,ipar,iparf,ipr1,
     +     iprint,iread,iref,isel,isp,ispgr,istr,istruc,isymm,
     +     itel,itot,iwrite,izoek,j,j1,j2,jclus,jj,k,m,
     +     maxtel,mindex,mnr,molind,msp,
     +     n,ncl,ndih,ndihh,nfound,ngr,mult,
     +     nhits,nimp,nindex,nj,nmol,nop,nop3,nout,nrp,nrpind,nrptot,
     +     nrsp,nsp,nspgr,nspgr1,nsym,nt,ntlist,ntmax,nword,nzlist,nzmax
      double precision ax,box,bx,by,cx,cy,cz,dener,ecl,
     +     eclus,emax,emin,ene,ener,enspf,rvol,tsp,vol,volspf,x
      character*5 panm(maxnrp),atname(maxnrp),naam
      character filenm*9,regel*200,spact*12,titl3*60
      character*80 titl1,titl2,titel(maxspf),titl4(10000)
      character*20 spnaam(mxspin),splist(mxlist)
      character*300 regel1,regel2,buffer(maxstr)
      dimension box(12),x(3*maxnrp),import(mxlist),impr(mxlist),
     +     nindex(maxstr),enspf(maxspf),volspf(maxspf),iref(12),
     +     ener(maxstr),vol(maxstr),inlist(maxstr),indbuf(maxstr),
     +     nrsp(mxspin),nsym(mxspin),imp(mxspin),nzlist(24),ntlist(24),
     +     tsp(3*maxspg,mxspin),msp(3*maxspg,mxspin),
     +     eclus(maxstr),mindex(maxstr),jclus(maxstr)

      open(unit=16,file='out.dcl')
      print*,geel,' D I S T C L U S',wit
      write(16,*) ' '
      write(16,*) ' D I S T C L U S'
      intra=0
      isel=1
      do i=1,100
         import(i)=100-i
      enddo
      do i=1,maxstr
         eclus(i)=0
      enddo
      isymm=1
      cutoff=0.5d0
      tol=-10
      diff=-10
      margin=0
      dener=1
      rvol=0.01d0
      iprint=0
      inspf=0
      titl2='xxxxx'
      emin=1.0d20
      emax=1.0d20
      mult=0
      ncl=0
      do i=1,mxlist
         splist(i)='unknown'
      enddo
      
C     Read general space group information
      nsp=0
      open(unit=11,file='in.spg',status='OLD',iostat=ios)
      if (ios.ne.0) then
         print*,' No file IN.SPG present'
         write(16,*) ' No file IN.SPG present'
      else
 110     continue
C        Read next entry from space group file
         nsp=nsp+1
         if (nsp.gt.mxspin) then
            print*,' ***** Increase MXSPIN',nsp,mxspin
            stop
         endif
 115     continue
         read(11,20,end=120,err=930) spnaam(nsp)
         if (spnaam(nsp).eq.'   ') goto 115
         read(11,*,end=120,err=930) nrsp(nsp),nsym(nsp),imp(nsp)
         do i=1,nsym(nsp)
            j=3*i-3
            read(11,*) (msp(j+m,nsp),tsp(j+m,nsp),m=1,3)
         enddo
         read(11,*) (iref(m),m=1,12)
         read(11,15) regel2
         goto 110
 120     continue
         close(11)
         nsp=nsp-1
         print*,nsp,' entries read from space group file'
         write(16,*) nsp,' entries read from space group file'
      endif

C     Read general information
      open(unit=20,file='in.tp',status='OLD',err=160)
      read(20,11) regel
      print 29,regel
      write(16,29) regel
      read(20,11) regel
      if (regel(8:17) .eq. 'atom types') then
         print*,' ***** Outdated version of topology file'
         write(16,*) ' ***** Outdated version of topology file'
 105     continue
         read(20,11) regel
         if (regel(8:12).ne.'atoms') goto 105
      endif
      read(regel,25) nrp
      read(20,11) regel
      mnr=1
      do i=1,nrp
         read(20,11) regel
         call intstr(regel,1,j)
         molnr(i)=mnr
         if (j.lt.0) mnr=mnr+1
         call strext(regel,2,panm(i)(1:5))
         call intstr(regel,3,type(i))
      enddo
      close(20)

      open(unit=13,file='in.dcl',status='OLD',iostat=ios)
cc      nrp=0
      if (ios.ne.0) then
         print*,' No file IN.DCL present'
         write(16,*) ' No file IN.DCL present'
      else
C        Read general information from file IN.DCL
         regel=' '
         n=inpt('INPUT ',regel)
         close(13)
         n=inpt('CUTOFF',regel)
         if (n.ge.2) call realst(regel,2,cutoff)
         n=inpt('DIFF  ',regel)
         if (n.ge.2) call realst(regel,2,diff)
         n=inpt('MARGIN',regel)
         if (n.ge.2) call intstr(regel,2,margin)
         n=inpt('SYM   ',regel)
         if (n.ge.2) call intstr(regel,2,isymm)
         n=inpt('DENER ',regel)
         if (n.ge.2) call realst(regel,2,dener)
         n=inpt('RVOL  ',regel)
         if (n.ge.2) call realst(regel,2,rvol)
         n=inpt('TOL   ',regel)
         if (n.ge.2) call realst(regel,2,tol)
         n=inpt('PRINT ',regel)
         if (n.ge.2) call intstr(regel,2,iprint)
         n=inpt('SELECT',regel)
         if (n.ge.2) call intstr(regel,2,isel)

         nimp=0
         n=inpt('IMPORT',regel)
         if (n.ge.2) then
            nimp=n-1
            do i=1,nimp
               call intstr(regel,i+1,impr(i))
            enddo
         endif
         n=inpt('EMAX  ',regel)
         if (n.ge.2) call realst(regel,2,emax)
         n=inpt('MULT  ',regel)
         if (n.ge.1) then
            mult=1
            open(unit=888,file='multiples')
         endif
         n=inpt('INTRA ',regel)
         if (n.gt.0) then
            intra=(n-1)/2
            if (intra.gt.mxindi) then
               print*,' ***** Increase MXINTR',intra,mxintr
               stop
            endif
            if (2*intra.ne.n-1) then
               print*,' ***** Wrong data for intramolecular distances'
               stop
            endif
            do i=1,intra
               call intstr(regel,2*i,intri(i))
               call intstr(regel,2*i+1,intrj(i))
            enddo
         endif

         n=inpt('ATOM  ',regel)
         if (n.gt.0) then
            open(unit=13,file='in.dcl')
 130        continue
            read(13,15) regel2
            if (regel2(1:4).ne.'atom' .and. regel2(1:4).ne.'ATOM')
     +           goto 130
            mnr=1
            nrp=0
 140        continue
            read(13,15,end=150,err=150) regel2
            if (nword(regel2).lt.3) goto 150
            nrp=nrp+1
            call intstr(regel2,1,k)
            call strext(regel2,2,naam)
            call intstr(regel2,3,type(nrp))
            if (naam.ne.panm(nrp)) then
               print*,' ***** Wrong name for atom',nrp,': ',
     +              naam,'  rather than  ',panm(nrp)
               stop
            endif
            if (mnr.ne.molnr(nrp)) then
               print*,' ***** Wrong molecule number for atom',nrp,': ',
     +              mnr,' rather than',molnr(nrp)
               stop
            endif
            if (k.lt.0) mnr=mnr+1
            if (type(nrp).gt.99) then
               print*,' type must be smaller than 100'
               stop
            endif
            goto 140
 150        continue
         endif
         close(13)
      endif

 160  continue
      if (nrp.eq.0) then
         print*,' No atom data on file IN.TP, try FORT.201'
         open(10,status='OLD',file='fort.201',iostat=iosp)
         if (iosp.eq.0) then
            mnr=1
            read(10,15,err=170) regel2
            read(10,94,err=170) ndih,ndihh
            do i=1,ndih+ndihh
               read(10,15,err=170) regel2
C              Do not use this dihedral angle information:
C              it is too sensitive for symmetry complications
            enddo
C           Read atom information
            read(10,94,err=170) nrp
            do i=1,nrp
               read(10,72) k,panm(i)(1:5),type(i)
               molnr(i)=mnr
               if (k.lt.0) mnr=mnr+1
            enddo
            close(10)
         endif
      endif
      
 170  continue
      if (nrp.eq.0) then
         print*,' No atom data on file FORT.201, try IN.EXP'
         open(unit=15,file='in.exp',status='OLD',iostat=ios)
         if (ios.ne.0) then
            print*,' No atom data on file IN.EXP, try IN.SPF'
            open(unit=15,file='in.spf',status='OLD',iostat=ios)
            if (ios.ne.0) then
               print*,' ***** Still no atom data found!'
               stop
            endif
         endif
         call leess(15,nsp,nrsp,nsym,tsp,msp,spnaam,
     +        nrp,nspgr,titl1,panm,box,x,ene,ierr,0,iprint)
         close(15)
         do i=1,nrp
            type(i)=i
            molnr(i)=1
         enddo
      endif

C     All general data are now available.
      nmol=molnr(nrp)
      print*,'     Atom   Type   Molecule'
      write(16,*) '     Atom   Type   Molecule'
      do i=1,nrp
         print 17,i,panm(i),type(i),molnr(i)
         write(16,17) i,panm(i),type(i),molnr(i)
      enddo
      if (intra.gt.0) then
         print 18, (intri(i),intrj(i),i=1,intra)
         write(16,18) (intri(i),intrj(i),i=1,intra)
      endif
      do i=1,intra
         if (intri(i).gt.nrp) then
            print*,' *****',intri(i),' too large'
            stop
         endif
         if (intrj(i).gt.nrp) then
            print*,' *****',intrj(i),' too large'
            stop
         endif
      enddo

      print 38,nrp,   '  atoms in each group'
      print 38,nmol,  '  molecules in each group'
      print 39,cutoff,'  cutoff limit for pair list'
      print 38,margin,'  acceptable number of missed contacts'
      print 39,dener, '  acceptable energy difference'
      print 37,rvol,  '  acceptable relative volume difference'
      write(16,38) nrp,   '  atoms in each group'
      write(16,38) nmol,  '  molecules in each group'
      write(16,39) cutoff,'  cutoff limit for pair list'
      write(16,38) margin,'  acceptable number of missed contacts'
      write(16,39) dener, '  acceptable energy difference'
      write(16,37) rvol,  '  acceptable relative volume difference'

      if (cutoff.gt.0.999) then
         print*,' ***** CUTOFF must be less than 1.0 nm for integer',
     +        '       reprentation of distances multiplied by',mpow
         stop
      endif

C     Expand data for the maximum allowed number of groups
      do i=2,maxnrp/nrp
         do j=1,nrp
            type(j+(i-1)*nrp)=type(j)
            panm(j+(i-1)*nrp)=panm(j)
            molnr(j+(i-1)*nrp)=molnr(j)+(i-1)*nmol
         enddo
      enddo
      if (intra.gt.0) then
         do i=2,mxintr/intra
            do k=1,intra
               intri(k+(i-1)*intra)=intri(k)+(i-1)*nrp
               intrj(k+(i-1)*intra)=intrj(k)+(i-1)*nrp
            enddo
         enddo
      endif

      istruc=0
      iparf=200
      icorf=100
      iwrite=300
      icount=0
      inbuf=0
      intot=0
      inpar=0
      inparp=0
      maxtel=0
      nhits=0
C     ISTRUC: number of structure
C     ICOUNT: number of PACK-type input file
C     ISTART(ICOUNT): number of first structure of ICOUNT
C     IEND(ICOUNT):   number of last structure of ICOUNT
C     Try opening the file SPLIST containing space group names
      open(unit=777,file='splist',status='OLD',iostat=iospl)

C     Try opening SPF-type file IN.EXP containing the experimental structure
      open(unit=15,file='in.exp',status='OLD',iostat=ios)
      if (ios.ne.0) then
         izoek=0
         if (tol.lt.-9) tol=0.005d0
         print 37,tol,  '  allowed distance tolerance'
         write(16,37) tol,  '  allowed distance tolerance'
         print*,' No file IN.EXP present, do clustering'
         write(16,*)' No file IN.EXP present, do clustering'
         print*,' '
      else
C        Read SPF-type file IN.EXP containing the experimental structure
         izoek=1
         if (tol.lt.-9) tol=0.02d0
         print 37,tol,  '  allowed distance tolerance'
         write(16,37) tol,  '  allowed distance tolerance'
         print*,' File IN.EXP present, do search'
         write(16,*) ' File IN.EXP present, do search'
      endif

C     MPOW multiplies distances to make them integer
      mpow=100000
      if (diff.lt.-9) diff=1.1d0*tol
      mdiff=nint(mpow*tol)
cc      mcut=nint(mpow*(cutoff-diff))
      mcut=nint(mpow*(cutoff-1.1d0*tol))
C     Check on 4-byte integer
      n=2147000000
      if (n.ne.mpow*(n/mpow)) then
         print*,' ***** Change array DIST to integer*4'
         stop
      endif

      if (izoek.eq.1) then
         call leess(15,nsp,nrsp,nsym,tsp,msp,spnaam,
     +        nfound,nspgr,titl1,atname,box,x,ene,ierr,0,iprint)
         nspgr=0
         close(15)
         if (ierr.eq.1) then
            print*,' ***** Error reading file IN.EXP'
            stop
         endif
         if (ierr.eq.2) then
            print*,' ***** No cell given on file IN.EXP'
            stop
         endif
         if (ierr.eq.3) then
            print*,' ***** Incorrect space group data in file IN.EXP'
            stop
         endif
         ngr=nfound/nrp
         print*, ngr,'   group(s) found on file IN.EXP'
         write(16,*) ngr,'   group(s) found on file IN.EXP'
         if (nfound.ne.nrp*ngr) then
            print*,' ***** Number of atoms on file IN.EXP',
     +           'incorrect:',nfound,nrp,ngr
            stop
         endif
c      do i=1,nfound
c         if (atname(i).ne.panm(i)) print*,
c     +        ' ***** Atom',i,' has wrong name: ',
c     +        '---',atname(i),'--- rather than ---',panm(i),'---'
c      enddo
         dener=1.0d+30
         rvol=1.0d+30
         nrpind=ngr*nrp
         molind=ngr*nmol
         inttot=ngr*intra
         nrptot=ngr*nrp
         ener(1)=ene
         vol(1)=box(1)*box(2)*box(3)/ngr
         strlst(1)=1
         nindex(1)=1
         nindex(2)=2
         call dlist(1,box,x,nrpind,molind,nrptot,inttot,
     +        izoek,max(2,iprint),maxtel)
         print 96,titl1
         write(16,96) titl1
      endif

 200  continue
C     Try opening the next set of inputfiles (for the next space group)
      icorf=icorf+1
      iparf=iparf+1
      iwrite=iwrite+1
      ifiles=2
      write(filenm,21) 'fort.',iparf
      open(10,status='OLD',file=filenm,iostat=iosp)
      if (iosp.eq.0) then
         write(filenm,21) 'fort.',icorf
         open(14,status='OLD',file=filenm,iostat=iosc)
         if (iosc.eq.0) then
            goto 230
         else
            print 47,iparf,icorf
            stop
         endif
      endif

C     No (more) PACK-type parameter files, try SPF file
      print 45
      write(16,45)
      if (istruc.gt.0) then
         print 48,istruc,emin
         write(16,48) istruc,emin
      endif
      if (emax.lt.100000) then
         print 44,intot,emax
         write(16,44) intot,emax
         if (izoek.eq.0) then
ccc            print*,' Type ENTER if you wish to continue'
ccc            read 15, regel
         endif
      endif
      icorf=0
      ifiles=1
 220  continue
      icorf=icorf+1
      write(filenm,19) 'extra.',icorf
      open(14,status='OLD',file=filenm,iostat=ios)
      if (ios.eq.0) then
         print*,'Reading SPF-file ',filenm
         write(16,*) 'Reading SPF-file ',filenm
      else
         print*,'No (more) SPF-type files present'
         write(16,*) 'No (more) SPF-type files present'
         goto 500
      endif
      goto 300

 230  continue
C     Start writing outputfiles with unit 21
      write(filenm,21) 'fort.',iwrite
      ioutf=iwrite-280
      if (izoek.eq.0) open(ioutf,file=filenm,iostat=iosp)
C     Read pack.30-type parameter file: first find the space group data
cccc      inpar=0
      read(10,11,err=280,end=280) regel2
      if (izoek.eq.0) write(ioutf,11) regel2(1:80)
      read(regel2,94) ispgr
      do isp=1,nsp
         if (ispgr.eq.nrsp(isp)) then
            nspgr=nsym(isp)
            goto 240
         endif
      enddo
C     Space group not found on file
      print 90,ispgr
      stop
 240  continue
      print 40,ispgr,spnaam(isp),imp(isp)
      write(16,40) ispgr,spnaam(isp),imp(isp)
      if (iospl.eq.0) then
         read(777,11) regel2
         call intstr(regel2,2,ii)
         if (ii.ne.iparf) then
            print*,'***** Error reading splist:',ii,iparf
            iospl=1
            splist(icount+1)=spnaam(isp)
         else
            call strext(regel2,6,splist(icount+1))
         endif
      else
         splist(icount+1)=spnaam(isp)
      endif
      print*,'File name ',splist(icount+1)
      write(16,*) 'File name ',splist(icount+1)
      nspgr1=nspgr
      if (isymm.eq.0) then
         ispgr=1
         nspgr=0
         print*,'But changed to P1 because of SYM card'
         write(16,*) 'But changed to P1 because of SYM card'
      endif

C     Read and write superfluous data for dihedrals and atoms
      read(10,94) ndih,ndihh
      if (izoek.eq.0) write(ioutf,94) ndih,ndihh
      do i=1,ndih+ndihh
         read(10,11) regel2
         if (izoek.eq.0) write(ioutf,11) regel2(1:80)
      enddo
      read(10,11) regel2
      if (izoek.eq.0) write(ioutf,11) regel2(1:80)
      read(regel2,94) nt
      do i=1,nt+3
         read(10,11) regel2
         if (izoek.eq.0) write(ioutf,11) regel2(1:80)
      enddo
      if (nrp.ne.nt) then
         print*,' ***** Number of atoms incorrect!',nt,nrp
         stop
      endif

C     Select required entries from parameter file into file INLIST
      inparp=inparp+inpar
      inpar=0
      indeze=0
 270  continue
      read(10,15,end=280,err=280) regel2
      if (nword(regel2).lt.3) goto 270
      call realst(regel2,3,ene)
      if (ene.gt.emax) goto 270      
      inpar=inpar+1
      inbuf=inbuf+1
      buffer(inbuf)=regel2
      if (iprint.gt.3) print*, regel2
      call intstr(regel2,2,inlist(inpar))
      call intstr(regel2,2,inl)
      call realst(regel2,3,ene)
      if (ene.lt.emin) emin=ene
      if (ene.le.emax) then
         indeze=indeze+1
         intot=intot+1
         if (iprint.gt.3) print 32,indeze,intot,inl,ene
      endif
      if (izoek.eq.0 .and. inbuf.gt.maxstr) then
         print*,' ***** Increase MAXSTRUC',inbuf
         stop
      endif
      goto 270
 280  continue
C     End reading parameterfile
      print 41,inpar,'parameter ',iparf
      write(16,41) inpar,'parameter ',iparf
      if (emax.lt.100000) then
         print 43,indeze,emax,intot
         write(16,43) indeze,emax,intot
      endif

      if (inpar.eq.0) print*,' ***** no structures!!'
      close(10)

 300  continue
C     Start reading a new coordinate file: cell parameters and atom coordinate
      if (ifiles.eq.1) then
         print*,'   Now reading data from SPF-type file'
         write(16,*) '   Now reading data from SPF-type file'
      endif
      icount=icount+1
      istart(icount)=istruc+1
      if (icount.ge.mxlist) then
         print*,' ***** ',icount, ' lists, maximum',mxlist
         stop
      endif
      istart(icount)=istruc+1
      incor=0
      iread=0

 400  continue
C     Read next entry from file
      if (ifiles.eq.1) then
C        Reading cluster of SPF-files
         ipr1=iprint-1
         call leess(14,nsp,nrsp,nsym,tsp,msp,spnaam,
     +        nfound,nspgr,titl2,atname,box,x,ene,ierr,0,ipr1)
         if (ierr.eq.1) goto 460
         if (ierr.eq.2) goto 400
C        IERR=0: no error status
C        IERR=1: no first line found
C        IERR=2: no cell data found
         if (ene.gt.emax) goto 400
         if (ene.lt.-1.0d+9) ene=0
         nspgr=0
         ngr=nfound/nrp
         if (nfound.ne.nrp*ngr) then
            print 23, nfound,nrp,ngr,incor,titl2(1:65)
            write(16,23) nfound,nrp,ngr,incor,titl2(1:65)
            goto 400
         endif
         do i=1,nfound
            if (atname(i).ne.panm(i)) then
               print*,' ***** Atom',i,' has wrong name: ',
     +              '---',atname(i),'--- rather than ---',panm(i),'---'
               print 24, nfound,nrp,ngr,incor,titl2(1:65)
c               goto 400
C              Sometimes this goto statement is preferable.
            endif
         enddo
         nrpind=ngr*nrp
         molind=ngr*nmol
         inttot=ngr*intra
         nrptot=ngr*nrp
         incor=incor+1
         istruc=istruc+1
         istr=istruc
         if (iprint.gt.1) then
            print 36, ngr,istruc,incor,titl2
            write(16,36) ngr,istruc,incor,titl2
         endif
         if (izoek.eq.1) then
            istr=2
         else
            if (istruc.gt.maxstr) then
               print*,' ***** Increase MAXSTRUC',istruc
               stop
            endif
         endif
         if (iprint.gt.1 .or. ierr.gt.0) then
            print 22,istruc,incor,icount
            write(16,22) istruc,incor,icount
         endif
         strlst(istr)=incor
         ener(istr)=ene
         nclus(istr)=1
         inbuf=inbuf+1
         buffer(inbuf)=titl2
         indbuf(istr)=inbuf
         vol(istr)=box(1)*box(2)*box(3)/ngr
         inspf=inspf+1
         if (inspf.gt.maxspf) then
            print*,' ***** Increase MAXSPF',inspf
            stop
         endif
         titel(inspf)=titl2
         enspf(inspf)=ene
         volspf(inspf)=vol(istr)
      else
C        Read box and coordinates from PACK-39 type file
         if (iread.eq.1) then
            iread=2
            read(regel2,97,end=460,err=460) icode,(box(i),i=1,6)
         else
            read(14,97,end=460,err=950) icode,(box(i),i=1,6)
         endif
         if (iread.eq.0) then
            iread=1
C           Determine NGR for this file
            j1=1
 430        continue
            i=1
            read(14,15,end=440,err=960) regel2
            do i=172,1,-1
               if (regel2(i:i).ne.' ') goto 440
            enddo
 440        continue
            n=i/8
            if (8*n.eq.i) then
               j2=j1+n-1
               read(regel2,98,end=460,err=960) (x(i),i=j1,j2)
               j1=j2+1
               goto 430
            else
C              X contains the coordinates, and REGEL2 contains the second box.
               ngr=j2/(3*nrp)
               if (3*ngr*nrp.ne.j2) then
                  print*,' ***** Wrong number of atoms on coordinate ',
     +                 'file',icorf,j2,nrp,ngr
                  stop
               endif
               print 42, ngr,nspgr1+1
               write(16,42) ngr,nspgr1+1
            endif
            import(icount)=imp(isp)+1450-500*ngr
            do j=1,icount-1
               if (import(j).eq.import(icount)) then
                  import(icount)=import(icount)-50
               endif
            enddo
            print 62,icount,import(icount)
         else
            read(14,98,end=460,err=960) (x(i),i=1,3*ngr*nrp)
         endif

C        Check whether this entry occurs in the selected set INLIST
         do ientr=1,inpar
            if (icode.eq.inlist(ientr)) goto 450
         enddo
         goto 400
 450     continue
         incor=incor+1
         istruc=istruc+1
         istr=istruc
         if (izoek.eq.1) then
            istr=2
         else
            if (istruc.gt.maxstr) then
               print*,' ***** Increase MAXSTRUC',istruc
               stop
            endif
         endif
         nrpind=ngr*nrp
         molind=ngr*nmol
         inttot=ngr*intra*(nspgr+1)
         nrptot=ngr*nrp*(nspgr+1)
         strlst(istr)=icode
         k=ientr+inparp
         indbuf(istr)=k
         regel1=buffer(k)
         n=nword(regel1)
         call realst(regel1,3,ener(istr))
         call intstr(regel1,n,nclus(istr))
         vol(istr)=box(1)*box(2)*box(3)/(ngr*(nspgr+1))
         ax=box(1)
         by=box(2)
         cz=box(3)
         bx=box(4)
         cx=box(5)
         cy=box(6)
C        Expand nanometer coordinates following space group symmetry
         if (nspgr.gt.0) then
            do nop=1,nspgr
               nop3=3*nop-3
               do i=1,nrpind
                  j=3*i-3
                  k=j+nop*3*nrpind
                  x(k+1)=msp(nop3+1,isp)*x(j+1)+tsp(nop3+1,isp)*ax+
     +                 tsp(nop3+2,isp)*bx+tsp(nop3+3,isp)*cx
                  x(k+2)=msp(nop3+2,isp)*x(j+2)+
     +                 tsp(nop3+2,isp)*by+tsp(nop3+3,isp)*cy
                  x(k+3)=msp(nop3+3,isp)*x(j+3)+tsp(nop3+3,isp)*cz
               enddo
            enddo
         endif
      endif

      if (izoek.eq.1) then
         call dlist(2,box,x,nrpind,molind,nrptot,inttot,
     +        izoek,iprint,maxtel)
         iend(icount)=istruc
         call dclus(icount,2,nindex,ener,vol,dener,rvol,
     +        import,isel,izoek,ihit,iprint)
         nhits=nhits+ihit
         if (ener(2).lt.emin) emin=ener(2)
         if (ihit.eq.1) then
            ener(nhits+10)=ener(2)
            nindex(nhits+10)=strlst(2)
         endif
c         print*,ener(1),ener(2),ihit,strlst(1),strlst(2)
         if (ihit.eq.1 .and. titl2(1:5).ne.'xxxxx') then
            print 95,titl2
            write(16,95) titl2
            if (iprint.gt.1) print 55
            if (iprint.gt.1) write(16,55)
         endif
      else
         call dlist(istruc,box,x,nrpind,molind,nrptot,inttot,
     +        izoek,iprint,maxtel)
      endif
      goto 400

 460  continue
      close(14)
C     End reading this coordinate file
      iend(icount)=istruc
      print 41,incor,'coordinate',icorf
      write(16,41) incor,'coordinate',icorf
      if (ifiles.eq.1) then
c         import(icount)=0
         print 62,icount,import(icount)
      endif
      if (incor.eq.0) print*,' ***** no structures!!'
      if (icorf.gt.100 .and. incor.ne.inpar) then
         print 46,icount,incor,inpar
         write(16,46) icount,incor,inpar
      endif
      iend(icount)=istruc
C     Continue with the next input file
      if (ifiles.eq.2) goto 200
      if (ifiles.eq.1) goto 220

 500  continue
C     End reading inputfiles
      if (istruc.eq.0) then
         print*,' ***** No coordinates found'
         stop
      endif
      if (izoek.eq.1) then
         print*,'Maximum number of contacts',maxtel
         write(16,*) 'Maximum number of contacts',maxtel
         print 61,ener(1)
         write(16,61) ener(1)
         if (nhits.eq.0) then
            print 60,ener(1)-emin
            write(16,60) ener(1)-emin
         else
            print*,nhits,' hits found out of',istruc
            write(16,*) nhits,' hits found out of',istruc
            print 57,emin
            write(16,57) emin
            do i=1,nhits
               print 58,nindex(i+10),ener(i+10),ener(i+10)-emin
               write(16,58) nindex(i+10),ener(i+10),ener(i+10)-emin
            enddo
         endif
         stop
      endif

      call sort(istruc,ener,nindex)
      print 64,(import(i),i=1,icount)
      write(16,64) (import(i),i=1,icount)
      if (nimp.gt.0) then
         do i=1,nimp
            import(i)=impr(i)
         enddo
         print*,'  Modified by IMPORT card to:'
         write(16,*) '  Modified by IMPORT card to:'
         print 64,(import(i),i=1,icount)
         write(16,64) (import(i),i=1,icount)
      endif

c      do i=1,istruc
c         print*,i,strlst(i),ener(i),vol(i),
c     +        strlst(nindex(i)),ener(nindex(i)),vol(nindex(i))
c      enddo
      print 49,maxtel
      write(16,49) maxtel
      call dclus(icount,istruc,nindex,ener,vol,dener,rvol,
     +     import,isel,izoek,idum,iprint)
      ipar=icount
      icorf=icorf-1
      if (inspf.gt.0) ipar=icount-icorf

C     Determine lowest energy for each cluster and sort
      do i=1,istruc
         nj=0
         do j=1,istruc
            if (iclus(j).eq.i) then
C              One structure found in cluster numbered I
               nj=nj+1
               if (nj.eq.1) then
                  ncl=ncl+1
                  eclus(ncl)=1.0d+20
               endif
               jclus(j)=ncl
               ecl=ener(j)
c               print*,i,j,iclus(j),ecl,jclus(j)
               if (ecl.lt.eclus(ncl) .and. 
     +              abs(ecl).lt.1.0d+8) eclus(ncl)=ecl
            endif
         enddo
c         if (nj.gt.0) print*,'Cluster',ncl,' lowest energy',eclus(ncl)
      enddo
      call sort(ncl,eclus,mindex)
c      do i=1,istruc
c         print*,i,iclus(i),mindex(i),mindex(iclus(i))
c     +        ,jclus(i),mindex(jclus(i))
c      enddo

C     Output of clusters of structures to unit 19
      print*,' Writing list of clusters'
      write(16,*) ' Writing list of clusters'
      open(unit=19,file='allstruc')
      itel=0
      if (iprint.gt.1) then
         print 66
         write(16,66)
      endif
      write(19,66)
      do i=1,ncl
         nj=0
         do j=1,istruc
c            print*,i,j,iclus(j),mindex(iclus(j))
            if (mindex(i).eq.jclus(j)) then
C              One structure found in cluster numbered I
               nj=nj+1
               if (nj.eq.1) then
                  if (iprint.gt.1) then
                     print 68,i,eclus(jclus(j))
                     write(16,68) i,eclus(jclus(j))
                  endif
                  write(19,68) i,eclus(jclus(j))
               endif
               do ifil=1,ipar+icorf
                  if (j.ge.istart(ifil) .and. j.le.iend(ifil)) k=ifil
               enddo
               titl1=' '
               if (k.gt.ipar) then
C                 From SPF-file
                  write(regel1,63) ener(j)
                  titl1=buffer(indbuf(j))(1:80)
                  spact=titl1(1:12)
               else
                  regel1=buffer(indbuf(j))
                  spact=splist(k)(1:12)
 510              continue
                  if (spact(12:12).eq.' ') then
                     spact=' '//spact(1:11)
                     goto 510
                  endif
                  call intstr(regel1,2,m)
                  write(titl1,65) spact,m
               endif
               itel=itel+1
               titl4(nj)=titl1
               if (iprint.gt.1) then
                  print 67,itel,strlst(j),regel1(8:24),vol(j),k,
     +                 zflag(j),titl1
                  write(16,67) itel,strlst(j),regel1(8:24),vol(j),k,
     +                 zflag(j),titl1
               endif
ccc               print*, itel,strlst(j),regel1(8:24),vol(j),k,
ccc  +                 zflag(j),titl1
               write(19,67) itel,strlst(j),regel1(8:24),vol(j),k,
     +              zflag(j),titl1
            endif
         enddo
         if (nj.gt.0) then
            if (iprint.gt.1) then 
               print*,'This was cluster',i,' with',nj,' entries'
               write(16,*) 'This was cluster',i,' with',nj,' entries'
            endif
            write(19,*) 'This was cluster',i,' with',nj,' entries'
         endif
         if (mult.eq.1 .and. nj.gt.1) then
            if (nj.le.4) then
               write(888,69) nj,(titl4(k),k=1,nj)
            else
               write(888,69) nj,(titl4(k),k=1,4)
               write(888,70) (titl4(k),k=5,nj)
            endif
         endif
      enddo
      print*,' Total',ncl,' clusters',' with',itel,' entries'
      write(16,*) ' Total',ncl,' clusters',' with',itel,' entries'
      write(19,*) ' Total',ncl,' clusters',' with',itel,' entries'

C     Output of the best surviving structures (only NOUT to screen)
      open(unit=18,file='cluslist')
      itel=0
      nout=min(20,istruc)
      write(16,59) nout
      print 59,nout
      do i=1,istruc
         j=nindex(i)
         do ifil=1,ipar+icorf
            if (j.ge.istart(ifil) .and. j.le.iend(ifil)) k=ifil
         enddo
         titl1=' '
         if (k.gt.ipar) then
C           From SPF-file
            write(regel1,63) ener(j)
            titl1=buffer(indbuf(j))(1:80)
            spact=titl1(1:12)
c            print*,'TITL1:',titl1(1:80)
            titl3=titl1(1:40)
         else
            regel1=buffer(indbuf(j))
            spact=splist(k)(1:12)
 520        continue
            if (spact(12:12).eq.' ') then
               spact=' '//spact(1:11)
               goto 520
            endif
c            print*,'REGEL1:',regel1(1:80)
            call intstr(regel1,2,m)
            write(titl3,65) spact,m
         endif
         if (strflg(j).eq.0) then
            itel=itel+1
            if (itel.le.nout) then
               print 54,itel,regel1(8:24),vol(j),k,
     +              zflag(j),nclus(j),titl3
               write(16,54) itel,regel1(8:24),vol(j),k,
     +              zflag(j),nclus(j),titl3
            endif
            write(18,54) itel,regel1(8:24),vol(j),k,
     +           zflag(j),nclus(j),titl3
         endif
      enddo
      close(18)

C     Output of the surviving structures to new parameter files
      print 73,ipar
      write(16,73) ipar
      do j=1,24
         ntlist(j)=0
      enddo
      itot=0
      ntmax=0
      do ifil=1,ipar
         itel=0
         iparf=200+ifil
         ioutf=20+ifil
         do j=1,24
            nzlist(j)=0
         enddo
         nzmax=0
         i1=istart(ifil)
         i2=iend(ifil)
         infile=i2-i1+1
C        Sort outputfile to energy (using VOL as a scratch file)
         do i=1,infile
            vol(i)=ener(i+i1-1)
         enddo
         call sort(infile,vol,nindex)
         do i=1,infile
            j=nindex(i)+i1-1
            regel1=buffer(indbuf(j))
c            print 888,j,strlst(j),strflg(j),zflag(j),nclus(j),ener(j),
c     +           regel1(1:75)
c 888        format(5i6,f8.3,a)
            if (strflg(j).eq.0) then
               itel=itel+1
               if (itel.eq.1) then
                  do iendln=172,0,-1
                     if (regel1(iendln:iendln).ne.' ') goto 530
                  enddo
                  print*,' ***** Error in buffer'
                  stop
 530              continue
               endif
               k=zflag(j)
               nzlist(k)=nzlist(k)+1
               ntlist(k)=ntlist(k)+1
               if (k.gt.nzmax) then
                  nzmax=k
                  if (ntmax.lt.nzmax) ntmax=nzmax
               endif
               jj=nclus(j)
               if (jj.gt.9999 .or. jj.lt.0) jj=9999
               write(ioutf,14) itel,regel1(8:iendln),k,jj
            endif
         enddo
         print 50,iparf,splist(ifil),infile,
     +        itel,(nzlist(m),m=1,nzmax)
         write(16,50) iparf,splist(ifil),infile,
     +        itel,(nzlist(m),m=1,nzmax)
         itot=itot+itel
      enddo
      if (ipar.gt.1) then
         print 52,istruc,itot,(ntlist(m),m=1,ntmax)
         write(16,52) istruc,itot,(ntlist(m),m=1,ntmax)
      endif

C     Print and write results from SPF file
      if (inspf.gt.0) then
         do ifil=1,icorf
            itel=0
            do j=1,24
               nzlist(j)=0
            enddo
            nzmax=0
            i1=istart(ipar+ifil)
            i2=iend(ipar+ifil)
            infile=i2-i1+1
            do i=1,infile
               j=i+i1-1
               if (strflg(j).eq.0) then
                  itel=itel+1
                  k=zflag(j)
                  nzlist(k)=nzlist(k)+1
                  if (k.gt.nzmax) nzmax=k
               endif
            enddo
            print 51,ifil,infile,itel,(nzlist(m),m=1,nzmax)
            write(16,51) ifil,infile,itel,(nzlist(m),m=1,nzmax)
            if (iprint.gt.1) print 56
            if (iprint.gt.1) write(16,56)
         enddo
         itel=0
         do jj=1,inspf
            j=jj+istart(ipar+1)-1
            if (strflg(j).eq.0) then
               itel=itel+1
               if (iprint.gt.1) then
                  print 53,itel,jj,enspf(jj),volspf(jj),
     +                 zflag(j),nclus(j),titel(jj)
                  write(16,53) itel,jj,enspf(jj),volspf(jj),
     +                 zflag(j),nclus(j),titel(jj)
               endif
            endif
         enddo

         print*,'Making output for SPF-type file(s).'
         write(16,*) 'Making output for SPF-type file(s).'
         do ifil=1,icorf
            write(filenm,12) 'select.',ifil
            open(unit=15,file=filenm)
            write(filenm,12) 'remove.',ifil
            open(unit=13,file=filenm)
            write(13,*) '# To remove these files, execute this file'
            write(13,*) '# To move to directory weg, remove first block'
            do j=1,istruc
               if (j.ge.istart(ipar+ifil) .and. 
     +              j.le.iend(ipar+ifil)) then
                  titl3=buffer(indbuf(j))(1:40)
                  do k=40,1,-1
                     if (titl3(k:k).ne.' ') then
                        do m=k,1,-1
                           if (titl3(m:m).eq.'.') then
                              titl3(m:m+k)='  '
                              goto 540
                           endif
                        enddo
                        goto 550
                     endif
                  enddo
 540              continue
                  k=m-1
c                  print*,k,'---',titl3(1:k),'---'
 550              continue
                  if (strflg(j).eq.0) then
c                     print 13,ifil,titl3
                     write(15,13) ifil,titl3
                  else
                     titl3(k+1:k+2)='.*'
c                     print 16,ifil,titl3
                     write(13,16) titl3,ifil,titl3
                  endif
               endif
            enddo
         enddo
      endif

      i=inpt('CHECK ',regel)
      stop

 930  print*,' ***** Error reading space group file IN.SPG'
      stop
 950  print*,' ***** Error reading box from coordinate file',
     +     icorf,nrp,incor,ngr,nmol
      print*, 'This error occurred after structure',
     +     istruc,strlst(istruc)
      stop
 960  print*,' ***** Error reading coordinate file',
     +     iread,icorf,nrp,incor,ngr,nmol
      print*, 'This error occurred after structure', 
     +     istruc,strlst(istruc)
      print*,regel2
      stop

 11   format(a)
 12   format(a7,i1.1)
 13   format('Kept from SPF-list',i3,': ',a)
 14   format(i7,a,i7,i5)
 15   format(a)
 16   format('rm  ',a30,'  #From SPF-list',i3,'   mv',a30,'  weg')
 17   format(i4,4x,a5,i4,i8)
 18   format('Equivalencies: ',20(3x,2i4))
 19   format(a6,i1.1)
 20   format(a)
 21   format(a5,i3.3)
 22   format('    This is structure',i5,' being',i5,' from list',i3)
 23   format(' ***** Number of atoms on file IN.SPF',
     +     ' incorrect:',4i5,2x,a65)
 24   format(23x,' nfound, nrp, ngr, incor:',4i5,2x,a65)
 25   format(i5,5x,a5)
c     26 format(' Frequencies for Z" =      1     2     3     4 ...')
c     27 format(22x,20i6)
c     28 format(' Smallest and largest numer of shells:',2i5)
 29   format(' Reading topology data from: ',a80)
 32   format(2i6,i10,f10.3)
 36   format(i4,' group(s) found for structure',2i5,' titled: ',a)
 37   format(f9.4,a)
 38   format(i9,a)
 39   format(f9.2,a)
 40   format(/,' Space group',i5,2x,a10,'having importance',i5)
 41   format(' There were',i6,' structures read from ',a10,' file ',i4)
 42   format(' NGR =',i4,' was determined from the coordinate file',
     +     '  (compare Z =',i3,')')
 43   format(' Of these there were', i5,' structures with energy ',
     +     'smaller than',f10.3,5x,'Total',i5)
 44   format(' There are ',i5,' structures',
     +     ' with energy smaller than',f10.3)
 45   format(/,' No (more) PACK-type parameter files')
 46   format(' Number of entries on parameter file ',i5,
     +     '   differs from coordinate file:',2i6)
 47   format(/,' ***** Parameter file',i5,' is present, but ',
     +     'corresponding coordinate file',i5,' is absent')
 48   format(' Total number of structures on PACK-files', i7,
     +     '   Lowest energy',f10.3)
 49   format(/,'Starting DCLUS; maximum number of contacts',i8)
 50   format(' File',i5,'   space group ',a12,' has',i6,
     +     ' entries, of which',i6,' are left: ',30i6)
 51   format(' File EXTRA.',i1,25x,'has',i6,
     +     ' entries, of which',i6,' are left: ',30i6)
 52   format(17x,' In total there were',i6,
     +     ' entries, of which',i6,' are left: ',30i6)
 53   format(2i6,2x,f10.3,f10.6,i5,i7,3x,a)
 54   format(i5,1x,a,f10.5,i6,i6,i7,3x,a)
 55   format('---------------------------------------')
 56   format(8x,'Number    Energy    Volume   Z"   Mult   Spgr'
     +     ,'       Title')
 57   format(' List of hits compared to lowest energy',f10.3)
 58   format(' Number',i6,'     Energy',f10.3,'       Delta-E',f10.3)
 59   format(/,' List of',i4,' best structures',/,
     +     ' Rank  Number    Energy    Volume  List',
     +     '    Z"  Nclus            Title')
 60   format(' No hits found, Delta-E =',f9.3)
 61   format(' Experimental energy ',f10.3)
 62   format(' This is file #',i3,' with importance',i5)
 63   format(11x,'SPF',f10.3)
 64   format(' Importance order',50i4)
 65   format(a,'-',i5.5)
 66   format(/,' List of clusters of structures',/,
     +     '       Number        Energy     Volume  List',
     +     '    Z"   Title')
 67   format(i5,i7,1x,a,f10.5,i6,i6,3x,a)
 68   format('Cluster',i4,'   Emin',f10.3)
 69   format(i5,4a30)
 70   format(5x,4a30)
 72   format(i5,5x,a5,i5,6f8.4)
 73   format(/,' Clustering done, writing',i5,' parameter file(s).',
     +     11x,' Frequencies for Z" =      1     2     3     4 ...')
 90   format(' ***** Space group number',i4,' not found')
 94   format(12i5)
 95   format(10x,'This is the structure titled: ',a)
 96   format(10x,'This is the experimental structure titled: ',a)
 97   format(i7,2x,7f8.4)
 98   format(15f8.5)
      end
