      subroutine listp(ngr,nrp,enb,nf,der,box,x,f)

C     Version of LIST to include polarization.
C       R. Milot, December 1994 - February 1995
C       adding of damping B.P. van Eijck, February 1995
C     No virial calculation (NF=2 not implemented)
C     No effect of U2-inner on polarization included

C     Input and output through common block /POLA/: see NONBEP.
C     See LIST for further description.
C     Note: for testing derivatives with procedure TEST use a very small
C     value of POLTOL to ensure that LISTP gives reproducible results!

C     Calls subroutine LISTK

      implicit none
      include 'params.i'
      include 'cnonb.i'
      include 'cvira.i'
      include 'cnbal.i'
      include 'cwald.i'
      include 'cpola.i'

      double precision al6kw,atsqpi,ax,bbb,box,bx,by,c6r,cbu,cgij,
     +     cx,cy,cz,denuli,denulj,der,df,
     +     dip1,dip2,dip3,djp1,djp2,djp3,ebu,enb,enul,eold,erfcc,
     +     emacht,euit,ewcoc,exa,f,f1,f23,f3,fact,fi,fj,
     +     p,pi,pipj,pir,pjr,qi,qj,rij,rij1,rij2,rij3,rij5,rij6,rklrij,
     +     rr,rs,rsm,rsn,w2,w3,wij,xx,yy,
     +     s1,s2,s3,stuk2,vda,vdr,vel,vol,vp3vn,
     +     x,xd,xij,xsqc,xsqlj,yd,yij,zd,zij
      integer i,ii,iim,
     +     is1,is2,is3,j,jj,jjm,
     +     k,m,n,nf,ngr,
     +     nr3,nrp,nrpt
      dimension der(*),box(*),x(*),f(*),rij(3),
     +     Euit(maxxco),enul(maxxco)
      logical skip

      nrpt=nrp*ngr
      nr3=3*nrpt
      if (nf.eq.2) then
         do m=1,3
            do n=1,3
               vira(m,n)=0
            enddo
         enddo
      endif
      do m=1,3
         if (box(m).lt.0.05) then
            print*,' ***** LISTP: Cell axes less than 0.5 Angstrom'
            write(16,*) ' ***** LISTP: Cell axes less than 0.5 Angstrom'
            enb=70000
            return
         endif
      enddo

      pi=4*atan(1.0d0)
      atsqpi=2*alphac/sqrt(pi)
      al6kw=alpha6**2
      ax=box(1)
      by=box(2)
      cz=box(3)
      bx=box(4)
      cx=box(5)
      cy=box(6)
      edc=0
      ed6=0
      ecc=0
      ec6=0
      ekc=0
      ek6=0
      edispa=0
      edispr=0
c      Epol=0
      do i=1,nr3
         enul(i)=0
      enddo

C     Calculate cell dipole moment and U2-inner; initialize derivatives
      uinner=0
      vol=ax*by*cz
      enb=druk*vol
c      vp3v=4.0*pi/(3.0*vol)
      vp3vn=finner/vol
C     This is twice the energy factor 2 pi / [3 V (nspgr+1)]
      do m=1,3
         p=0
         do i=1,nrpt
            p=p+x(3*i-3+m)*msom(m)*cg(i)
         enddo
         uinner=uinner-vp3vn*p*p/2
         pmol(m)=p
         if (inner.eq.0) p=0
         if (nf.gt.0) then
            do i=1,nrpt
               f(3*i-3+m)=vp3vn*msom(m)*cg(i)*p
            enddo
         endif
      enddo
C     Initialize field strengths with 4 pi dipool / [3 V]
ccc      do i=1,nrpt
ccc         do m=1,3
ccc            enul(3*i-3+m)=vp3v*pmol(m)
ccc         enddo
ccc      enddo
C     Decide whether to include U2-inner in EEL; initialize cell derivatives
      if (inner.ne.0) then
         eel=uinner
      else
         eel=0
      endif
      do m=1,3
         der(m)=(eel-enb)/box(m)
         der(m+3)=0
      enddo

      if (doew) call listk(nrpt,nf,der,box,x,f)

      do n=1,npla
         i=ipla1(n)
         skip=(i.lt.0)
         if (skip) i=-(i+1)
         j=ipla2(n)
            ii=i/3+1
            jj=j/3+1
            iim=mod(ii-1,nrp)+1
            jjm=mod(jj-1,nrp)+1
            qi=cg(ii)
            qj=cg(jj)
         s1=ishift1(n)/2.0d0
         s2=ishift2(n)/2.0d0
         s3=ishift3(n)/2.0d0
         is1=isig1(n)
         is2=isig2(n)
         is3=isig3(n)

         xij=x(i+1)-is1*x(j+1)+s1*ax+s2*bx+s3*cx
         yij=x(i+2)-is2*x(j+2)+s2*by+s3*cy
         zij=x(i+3)-is3*x(j+3)+s3*cz
         rij2=xij**2+yij**2+zij**2
         rij1=sqrt(rij2)
         rij6=rij2*rij2*rij2
         df=0
         if (rij1.lt.0.05) then
            print*,' LISTP: short distance: ',i,j,rij1
            enb=80000
            return
         endif

C        Calculate Coulomb energy
C        No distance dependent dielectric constant, even if DDC=TRUE.
         if (.not. skip) then
            vel=pcg(n)/rij1
            eel=eel+vel
            df=-vel/rij2
         endif
         if (doewc) then
C           Calculate Ewald correction
            cgij=pcgew(n)
            rklrij=alphac*rij1
            xsqc=rklrij*rklrij
            ewcoc=cgij*(erfcc(rklrij)-1)/rij1
            edc=edc+ewcoc
            df=df-(ewcoc+cgij*atsqpi*exp(-xsqc))/rij2
         endif

C        Calculate attractive r^(-6) terms
         if (.not. skip) then
            vda=plj6(n)/rij6
            edispa=edispa-vda
            df=df+6*vda/rij2
         endif
         c6r=plj6ew(n)/rij6
         if (doew6 .and. abs(c6r).gt.1.0d-10) then
C           Calculate Ewald correction
            xsqlj=al6kw*rij2
            exa=exp(-xsqlj)
            fact = (1 + xsqlj * (1 + xsqlj/2)) * exa - 1
            ed6=ed6-c6r*fact
            df=df+(c6r/rij2)*(6*fact+exa*xsqlj*xsqlj*xsqlj)
         endif

C        Calculate R^(-12) or exponential repulsion
         if (.not. skip) then
            if (buck) then
               cbu=plj12(n)
               ebu=pexp(n)
               vdr=cbu*exp(-ebu*rij1)
               df=df-ebu*vdr/rij1
            else
               vdr=plj12(n)/(rij6*rij6)
               df=df-12*vdr/rij2
            endif
            edispr=edispr+vdr
            if (edispr.gt.ebig) then
               enb=90000
               return
            endif
         endif

C        Calculate derivatives
         xd=xij*df
         yd=yij*df
         zd=zij*df
         f(i+1)=f(i+1)-xd
         f(i+2)=f(i+2)-yd
         f(i+3)=f(i+3)-zd
         f(j+1)=f(j+1)+xd*is1
         f(j+2)=f(j+2)+yd*is2
         f(j+3)=f(j+3)+zd*is3
         if (nf.eq.1) then
C           Calculate derivatives to cell axes
            der(1)=der(1)-xd*s1
            der(2)=der(2)-yd*s2
            der(3)=der(3)-zd*s3
            der(4)=der(4)-xd*s2
            der(5)=der(5)-xd*s3
            der(6)=der(6)-yd*s3
         endif
         if (nf.eq.2) then
C           Calculate virial
            rij(1)=xij
            rij(2)=yij
            rij(3)=zij
            do m=1,3
               do k=1,3
                  vira(m,k)=vira(m,k)+rij(m)*df*rij(k)
               enddo
            enddo
         endif

C        Calculate electric field for polarization calculation
C        Use damping if NNN>0.
         ii=i/3+1
         jj=j/3+1
         rs=rij1/(sij(iim,jjm)*schaal)
         if (nnn.gt.0) then
            f1=1-exp(-gampol*(rs**nnn))
         else
            f1=1
         endif
         rij3=rij1*rij2
         if (skip .and. nte.eq.0) goto 440
         denuli=qj*f1/rij3
         denulj=qi*f1/rij3
         enul(i+1)=enul(i+1)+xij*denuli
         enul(i+2)=enul(i+2)+yij*denuli
         enul(i+3)=enul(i+3)+zij*denuli
         if (i.ne.j) then
            enul(j+1)=enul(j+1)-xij*denulj*is1
            enul(j+2)=enul(j+2)-yij*denulj*is2
            enul(j+3)=enul(j+3)-zij*denulj*is3
         endif
 440     if (skip .and. nttt.eq.0) goto 450

C        Calculate T matrix, with damping if MMM>0.
         if (mmm.gt.0 .and. rs.lt.1) then
            wij=rs+(1-rs**mmm)/mmm
            f23=3*(wij**4)
            f3=4*(wij**3)-f23
         else
            f23=3
            f3=1
         endif
         T11(n)=((f23*xij*xij/rij2)-f3)/rij3
         T22(n)=((f23*yij*yij/rij2)-f3)/rij3
         T33(n)=((f23*zij*zij/rij2)-f3)/rij3
         T12(n)=(f23*xij*yij/rij2)/rij3
         T13(n)=(f23*xij*zij/rij2)/rij3
         T23(n)=(f23*yij*zij/rij2)/rij3
 450     continue
         r1(n)=xij
         r2(n)=yij
         r3(n)=zij
c         rabs(n)=rij1
      enddo

c      print 297, ' Listp:',npla,eel,edispa,edispr,epol,
c     +     enb+eel+edispa+edispr+epol

C     Start calculation of polarisation
C     One would hope that iteration would not be necessary for subsequent
C     calls of LISTP, but that does not appear to be the case.
      ncycp=0
 620  continue
      ncycp=ncycp+1
      do i=1,nr3
         Euit(i)=Enul(i)
      enddo
      Eold=Epol
      Epol=0
      do n=1,npla
         i=ipla1(n)
         skip=(i.lt.0)
         if (skip .and. nttt.eq.0) goto 640
         if (skip) i=-(i+1)
         j=ipla2(n)
            ii=i/3+1
            jj=j/3+1
            iim=mod(ii-1,nrp)+1
            jjm=mod(jj-1,nrp)+1
            qi=cg(ii)
            qj=cg(jj)
         is1=isig1(n)
         is2=isig2(n)
         is3=isig3(n)
         Euit(i+1)=Euit(i+1)+(T11(n)*dip(j+1)*is1
     +        +T12(n)*dip(j+2)*is2+T13(n)*dip(j+3)*is3)
         Euit(i+2)=Euit(i+2)+(T12(n)*dip(j+1)*is1
     +        +T22(n)*dip(j+2)*is2+T23(n)*dip(j+3)*is3)
         Euit(i+3)=Euit(i+3)+(T13(n)*dip(j+1)*is1
     +        +T23(n)*dip(j+2)*is2+T33(n)*dip(j+3)*is3)
         if (i.ne.j) then
            Euit(j+1)=Euit(j+1)+is1*(T11(n)*dip(i+1)
     +           +T12(n)*dip(i+2)+T13(n)*dip(i+3))
            Euit(j+2)=Euit(j+2)+is2*(T12(n)*dip(i+1)
     +           +T22(n)*dip(i+2)+T23(n)*dip(i+3))
            Euit(j+3)=Euit(j+3)+is3*(T13(n)*dip(i+1)
     +           +T23(n)*dip(i+2)+T33(n)*dip(i+3))
         endif
 640     continue
      enddo
      do i=1,nr3
         j=(i-1)/3+1
         xx=abs(Euit(i)*alfpol(j)/pmax(j))
         if (xx.lt.0.01) then
            yy=-xx/12
            dip(i)=alfpol(j)*Euit(i)*(1-xx/2)
         else
            rr=(1-exp(-xx))/xx
            yy=0.5d0+(rr-1)/(rr*xx)
            dip(i)=alfpol(j)*Euit(i)*rr
         endif
         Epol=Epol+dip(i)*(-Enul(i)/2+Euit(i)*yy)
      enddo
c      print*,' epol = ',epol,eold
      if (ncycp.lt.npp .and. abs(Eold-Epol).gt.poltol) goto 620

c      print*,' Dipoles LISTP:'
c      do 670 i=1,5
c         print*,i,enul(i),dip(i)
c 670  continue

C     Calculate intermolecular polarization forces
CCCCC (virial yet to be done!!)
CCCCC Ook Uinner nog in veld opnemen
      if (nf.eq.0) goto 700
      do n=1,npla
         i=ipla1(n)
         skip=(i.lt.0)
         if (skip .and. nte.eq.0 .and. nttt.eq.0) goto 690
         if (skip) i=-(i+1)
         j=ipla2(n)
            ii=i/3+1
            jj=j/3+1
            iim=mod(ii-1,nrp)+1
            jjm=mod(jj-1,nrp)+1
            qi=cg(ii)
            qj=cg(jj)
         is1=isig1(n)
         is2=isig2(n)
         is3=isig3(n)
         dip1=dip(i+1)
         dip2=dip(i+2)
         dip3=dip(i+3)
         djp1=dip(j+1)*is1
         djp2=dip(j+2)*is2
         djp3=dip(j+3)*is3
c         rij1=rabs(n)
c         rij2=rij1*rij1
         rij2=r1(n)**2+r2(n)**2+r3(n)**2
         rij1=sqrt(rij2)
         rij3=rij1*rij2
         rij5=rij2*rij3
         ii=i/3+1
         jj=j/3+1
            iim=mod(ii-1,nrp)+1
            jjm=mod(jj-1,nrp)+1
         rs=rij1/(sij(iim,jjm)*schaal)
         if (skip .and. nte.eq.0) then
            f1=0
            bbb=0
         else
            if (nnn.gt.0) then
               rsn=gampol*rs**nnn
               emacht=exp(-rsn)
               f1=1-emacht
               bbb=3*f1-nnn*rsn*emacht
            else
               f1=1
               bbb=3
            endif
         endif

         pjr=djp1*r1(n)+djp2*r2(n)+djp3*r3(n)
         pir=dip1*r1(n)+dip2*r2(n)+dip3*r3(n)
         pipj=dip1*djp1+dip2*djp2+dip3*djp3
         if (skip .and. nttt.eq.0) then
            stuk2=0
            f23=0
            f3=0
         else
            if (mmm.gt.0 .and. rs.lt.1) then
               rsm=rs**mmm
               wij=rs+(1-rsm)/mmm
               w2=wij*wij
               w3=wij*w2
               f23=3*w2*w2
               f3=4*w3-f23
               stuk2=-12*(pipj*(w2-w3)-(w3*pir*pjr/rij2))*(rs-rsm)
            else
               f23=3
               f3=1
               stuk2=0
            endif
         endif

         stuk2=((-qj*pir+qi*pjr)*bbb+3*pipj*f3
     +        -(5*f23*pjr*pir/rij2)+stuk2)/rij5
         fj=qj*f1/rij3+pjr*f23/rij5
         fi=qi*f1/rij3-pir*f23/rij5
         xd=dip1*fj-djp1*fi+stuk2*r1(n)
         yd=dip2*fj-djp2*fi+stuk2*r2(n)
         zd=dip3*fj-djp3*fi+stuk2*r3(n)

         if (i.eq.j) then
            xd=xd/2
            yd=yd/2
            zd=zd/2
         endif
         if (nf.eq.1) then
            der(1)=der(1)+xd*ishift1(n)/2
            der(2)=der(2)+yd*ishift2(n)/2
            der(3)=der(3)+zd*ishift3(n)/2
            der(4)=der(4)+xd*ishift2(n)/2
            der(5)=der(5)+xd*ishift3(n)/2
            der(6)=der(6)+yd*ishift3(n)/2
         endif
         f(i+1)=f(i+1)+xd
         f(i+2)=f(i+2)+yd
         f(i+3)=f(i+3)+zd
         f(j+1)=f(j+1)-xd*is1
         f(j+2)=f(j+2)-yd*is2
         f(j+3)=f(j+3)-zd*is3
 690     continue
      enddo
 700  continue

      if (doewc) eel=eel+ecc+ekc+edc
      if (doew6) edispa=edispa+ec6+ek6+ed6
      enb=enb+eel+edispa+edispr+Epol
      if (nf.eq.2) then
         do m=1,3
            do n=1,3
               vira(m,n)=vira(m,n)/2
            enddo
         enddo
      endif

c      write(94,297) ' Listp: ',eel,edispa,edispr,enb
c      write(94,298) (der(i),i=1,6)
c      write(95,299) (f(i),i=1,nr3)
c      print 297, '  Ewc: ',ecc,edc,ekc
c      print 297, '  Ew6: ',ec6,ed6,ek6
c      print 297, ' Energy Listp: ',eel,edispa,edispr,enb
c      print 296,(vira(1,m),m=1,3)
c      print 296,(vira(2,m),m=1,3)
c      print 296,(vira(3,m),m=1,3)
c      print 298, (der(i),i=1,6)
c      print 299, (f(i),i=1,nr3)

c 296  format (3f8.3)
c 297  format(a20,10f12.6)
c 298  format(' Der: ',6f12.6)
c 299  format(6f12.3)
      end
