      subroutine prod(v1,v2,v3)
C     Delivers the outer product of vectors V1 and V2 in V3.
      implicit none
      double precision v1,v2,v3
      dimension v1(3),v2(3),v3(3)
      v3(1)=v1(2)*v2(3)-v1(3)*v2(2)
      v3(2)=v1(3)*v2(1)-v1(1)*v2(3)
      v3(3)=v1(1)*v2(2)-v1(2)*v2(1)
      end



      subroutine norm(v)
C     Normalizes the vector V to a unit vector.
      implicit none
      integer m
      double precision v,r
      dimension v(3)
      r=0
      do m=1,3
         r=r+v(m)**2
      enddo
      r=sqrt(r)
      do m=1,3
         v(m)=v(m)/r
      enddo
      end


      function erfcc(x)
      implicit none
      double precision erfcc,T,x
      erfcc=0.0d0
      if (x.gt.25) return
      T=1/(1.0d0+0.5d0*x)
      erfcc=T*exp(-x*x-1.26551223d0+T*(1.00002368d0+T*(.37409196d0
     +     +T*(.09678418d0+T*(-.18628806d0+T*(.27886807d0
     +     +T*(-1.13520398d0
     +     +T*(1.48851587d0+T*(-.82215223d0+T*.17087277d0)))))))))
      end

C   Inlining is more efficient. Even less efficient turns out to be:
c      data erfc0,erfc1,erfc2,erfc3,erfc4,erfc5,erfc6,erfc7,erfc8,erfc9
c     +     /-1.26551223,1.00002368,0.37409196,0.09678418,-0.18628806,
c     +     0.27886807,-1.13520398,1.48851587,-0.82215223,0.17087277/
C   or:
c      erfc0=-1.26551223
c      erfc1= 1.00002368
c      erfc2= 0.37409196
c      erfc3= 0.09678418
c      erfc4=-0.18628806
c      erfc5= 0.27886807
c      erfc6=-1.13520398
c      erfc7= 1.48851587
c      erfc8=-0.82215223
c      erfc9= 0.17087277
C   followed by:
c      t=2/(2+x)
c      erfcc=t*exp(-x*x+erfc0+t*(erfc1+t*(erfc2+t*(erfc3+t*(erfc4+
c     +     t*(erfc5+t*(erfc6+t*(erfc7+t*(erfc8+t*erfc9)))))))))

      function random(iseed)
C     Generates random numbers. Adapted from RAN2, Numerical Recipes p. 197.
C     (Note that RAN2 gives an error if IDUM > IC, and that SAVE is necessary.
C     Restart if ISEED<0.
      implicit none
      integer i,im,ia,ic,iseed,index,inew,is,iseeds
      double precision random
      parameter(im=714025,ia=1366,ic=150889)
c      parameter(im=6075,ia=106,ic=1283)
      dimension iseeds(0:100)
      save
      data inew /0/
      if (inew.eq.0 .or. iseed.lt.0) then
         inew=1
         print*,' Initialize random number generator with seed', iseed
         iseed=mod(abs(iseed),im)
         do i=0,100
            iseed=mod(iseed*ia+ic,im)
            iseeds(i)=iseed
         enddo
         iseed=mod(iseed*ia+ic,im)
         is=iseed
      endif
      index=int(100*is/dfloat(im))
      is=iseeds(index)
      random=is/dfloat(im)
      iseed=mod(iseed*ia+ic,im)
      iseeds(index)=iseed
      end
