      program zoek

C     B.P. van Eijck, March 1996.
C     This program compares solutions from PACK-files with the experimental
C        structure.
C     Further input: file IN.SPG, IN.EXP, IN.ZK.

C     Input from the terminal: IFS
C          IFS=n, n<10: read all files PACK.n01, PACK.n02, ....
C                 n>10: read the file PACK.n  (e.g. PACK.31).
C     Output (same format) to files ZOEK.(same extension).

C     Input from tape IN.ZK: see manual.
C     Input from tape IN.EXP (prepared by PREP or by hand):
C     - BOXEXP(1..12): experimental crystal data
C     - TAU(1..NDIHZ+NDIHH): experimental dihedrals without/with H-atoms.

C     Uses subroutine DIFF

      implicit none
      include 'params.i'
      include 'cspgr.i'
      include 'color.i'
      integer i,i1,i2,i3,i4,icode,idih,idih1,idummy,ierr,ifs,ihit,ihit1,
     +     inner,inpt,inr,ios,ipar,iprint,iref,irefin,irot,iscr,ispgr,
     +     isym,itau,j,j1,j2,k,m,m123,msom,msym,n,ndih,ndih12,ndiha,
     +     ndihh,nhit,ninp,npar,nrot,nrp,nsym,nword
      double precision a1r1m,abox,ainv,box,boxexp,boxtr,c,ca,cb,cel,cg,
     +     costh,d,difa,difb,dih,dmax,drot,efirst,en,euler,phi,pi,psi,
     +     r2a2,rad,rot1,rot2,sa,sb,sg,tauexp,the,theta,tolb,tolh,toln,
     +     tolz,wrot,xref
      dimension itau(maxome),dih(maxome),tauexp(maxome),euler(3,3),
     +     rot2(3,3),rot1(3,3),wrot(3,3),dmax(maxome),iref(12),iscr(3),
     +     cel(12),irefin(12),ipar(12),box(12),boxexp(12),boxtr(12),
     +     msym(0:8,3),m123(0:8),msom(3),ihit(mxdata),ihit1(mxdata),
     +     abox(3,3),ainv(3,3),r2a2(3,3),a1r1m(3,3),xref(maxxco)
      character file0*9,file1*9,file2*9,adummy*250,regel*200
      character*8 panm,spname

      toln=0.40d0
      tolb=0.20d0
      tolz=30
      tolh=60
      m123(0)=1
      nsym=0
      nrot=1
      do i=1,3
         msym(0,i)=1
      enddo
      iprint=0
      spname='noname'
      open(unit=12,file='in.exp',status='OLD',err=960)
      print*,geel,' S E A R C H I N G',wit
      read(12,*) (boxexp(m),m=1,6)
      read(12,*) (boxexp(m),m=7,12)
      read(12,20,end=130,err=130) adummy
      ndih12=nword(adummy)
      do m=1,ndih12
         call realst(adummy,m,tauexp(m))
      enddo
      goto 140
  130 ndih12=0
      print*,'No dihedrals on file IN.EXP'
  140 continue
      close(12)

      open(unit=13,file='in.zk',status='OLD',iostat=ios)
      if (ios.ne.0) then
         print*,'No file IN.ZK present'
      else
         regel=' '
         n=inpt('INPUT ',regel)
         close(13)
      endif
      n=inpt('TOL   ',regel)
      if (n.ge.5) then
         call realst(regel,2,toln)
         call realst(regel,3,tolb)
         call realst(regel,4,tolz)
         call realst(regel,5,tolh)
      endif
      n=inpt('SYM   ',regel)
      if (n.ge.2) then
         call intstr(regel,2,nrot)
         nsym=(n-2)/3
         if (3*nsym.ne.n-2) then
            print*,' ***** Wrong number of data for NSYM',n,nsym
            stop
         endif
         do i=1,nsym
            call intstr(regel,3*i,msym(i,1))
            call intstr(regel,3*i+1,msym(i,2))
            call intstr(regel,3*i+2,msym(i,3))
            m123(i)=msym(i,1)*msym(i,2)*msym(i,3)
         enddo
      endif
      n=inpt('PRINT ',regel)
      if (n.ge.2) call intstr(regel,2,iprint)

      pi=4*atan(1.0d0)
      rad=180/pi
      drot=2*pi/nrot

      print*,'  Specify input file (0, 1, or file number): '
      read*,ifs
      print 21,ifs
      print 22,toln,tolb,tolz,tolh
      write(16,21) ifs
      write(16,22) toln,tolb,tolz,tolh
      if (nrot.gt.1) print*,' nrot =',nrot
      if (nsym.gt.0) then
         print*,' Symmetry codes:'
         do i=1,nsym
            print 94, (msym(i,j),j=1,3)
         enddo
      endif

      idih=0
  200 idih=idih+1
      if (ifs.gt.9) then
C        Open files IFS en IFS+1 (IFS>1)
         write(file1,16) 'pack.',ifs
         write(file2,16) 'zoek.',ifs
         open(unit=10,file=file1,status='OLD',err=980)
         open(unit=20,file=file2)
         read(10,13) regel
         call intstr(regel,1,ispgr)
         icode=0
         if (nword(regel).gt.1) call intstr(regel,2,icode)
         read(10,*) ndih,ndihh
         write(20,94) ispgr,icode
         write(20,94) ndih,ndihh
         if (icode.eq.0) goto 196
         ndiha=ndih+ndihh
         if (ndiha.ne.ndih12) then
            print*,' ***** Wrong number of dihedrals:',ndih,ndihh,ndih12
            stop
         endif
         do i=1,ndiha
            read(10,*) i1,i2,i3,i4
            write(20,87) i1,i2,i3,i4
         enddo
         read(10,*) nrp,(iscr(m),m=1,3)
         write(20,94) nrp,(iscr(m),m=1,3)
         do i=1,nrp
            read(10,72) k,panm(1:5),j,(xref(m),m=1,3)
            write(20,72) k,panm(1:5),j,(xref(m),m=1,3)
         enddo
  196    continue
      else
C        Open the next file of PACK.001, PACK.002, ...(IFS=0,1)
         write(file1,15) 'pack.',idih+ifs*100
         write(file2,15) 'zoek.',idih+ifs*100
         open(unit=10,file=file1,status='OLD',err=980)
         open(unit=20,file=file2)
         read(10,13) regel
         call intstr(regel,1,ispgr)
         icode=0
         ndihh=0
         if (nword(regel).gt.1) call intstr(regel,2,icode)
         write(20,94) ispgr,icode
         if (icode.eq.0) then
            read(10,*) ndih,(dih(i),i=1,ndih)
            write(20,94) ndih,0
            do i=1,ndih
               read(10,*) i1,i2,i3,i4
               write(20,87) i1,i2,i3,i4,dih(i)
            enddo
            goto 207
         endif
         read(10,*) ndih
         if (ndih.gt.ndih12) then
            print*,' ***** Wrong number of dihedrals:',ndih,ndih12
            stop
         endif
         write(20,94) ndih,ndihh
         do i=1,ndih
            read(10,*) i1,i2,i3,i4,dih(i)
            write(20,87) i1,i2,i3,i4,dih(i)
         enddo
  207    continue
         read(10,*) nrp,(iscr(m),m=1,3)
         write(20,94) nrp,(iscr(m),m=1,3)
         do i=1,nrp
            read(10,72) k,panm(1:5),j,(xref(m),m=1,3)
            write(20,72) k,panm(1:5),j,(xref(m),m=1,3)
         enddo
      endif

      ninp=0
      read(10,*) (cel(i),i=1,12)
      read(10,*) (irefin(i),i=1,12)
      write(20,93) (cel(i),i=1,12)
      write(20,94) (irefin(i),i=1,12)
      npar=0
      nhit=0
      do i=1,12
         if (irefin(i).gt.0) npar=npar+1
      enddo
      print*,'Number of parameters ', npar

      if (idih.eq.1) then
         call leesr(ispgr,spname,iref,iscr,msom,inner)
         do i=1,12
            if (irefin(i).ne.iref(i)) then
               print*,' iref',i,' inconsistent:',irefin(i),iref(i)
               print*,' ******* RESULTS UNRELIABLE !!'
            endif
         enddo
         ndiha=ndih+ndihh
         do i=1,ndih
            dmax(i)=tolz
         enddo
         do i=1,ndihh
            dmax(ndih+i)=tolh
         enddo
         print 82,(nint(1000*boxexp(m)),m=1,9),
     +        (nint(boxexp(m)),m=10,12),(nint(tauexp(m)),m=1,ndiha)
         write(16,82)(nint(1000*boxexp(m)),m=1,9),
     +        (nint(boxexp(m)),m=10,12),(nint(tauexp(m)),m=1,ndiha)

         phi=boxexp(10)/rad
         the=boxexp(11)/rad
         psi=boxexp(12)/rad
         ca=cos(phi)
         sa=sin(phi)
         cb=cos(the)
         sb=sin(the)
         cg=cos(psi)
         sg=sin(psi)
         rot2(1,1)= cg*ca-sg*sa*cb
         rot2(1,2)= cg*sa+sg*ca*cb
         rot2(1,3)= sg*sb
         rot2(2,1)=-sg*ca-cg*sa*cb
         rot2(2,2)=-sg*sa+cg*ca*cb
         rot2(2,3)= cg*sb
         rot2(3,1)= sa*sb
         rot2(3,2)=-ca*sb
         rot2(3,3)= cb
         abox(1,1)=boxexp(1)
         abox(1,2)=0
         abox(1,3)=0
         abox(2,1)=boxexp(4)
         abox(2,2)=boxexp(2)
         abox(2,3)=0
         abox(3,1)=boxexp(5)
         abox(3,2)=boxexp(6)
         abox(3,3)=boxexp(3)
         do i=1,3
            do j=1,3
               r2a2(i,j)=0
               do k=1,3
                  r2a2(i,j)=r2a2(i,j)+rot2(k,i)*abox(j,k)
               enddo
            enddo
         enddo
C        This is R2(transp).A2
         if (ifs.gt.9) goto 300
         ndiha=0
      endif

      print 45,file1
      do i=1,ndih
         print 46,i,dih(i),tauexp(i),tolz
         d=abs(dih(i)-tauexp(i))
         if (d.gt.180) d=d-360
         if (abs(d).gt.tolz) then
            print*,'  Dihedrals deviate too much'
            goto 200
         endif
      enddo

C     Read a structure to be tested
  300 continue
      read(10,12,iostat=ios) regel
      if (ios.lt.0) goto 400
      call intstr(regel,1,idummy)
      call intstr(regel,2,inr)
      call realst(regel,3,en)
      i=3
      do m=1,npar
         i=i+1
         call intstr(regel,i,ipar(m))
      enddo
      do m=1,ndiha
         i=i+1
         call intstr(regel,i,itau(m))
      enddo
      if (ifs.le.9) then
         do i=1,ndih
            itau(i)=nint(dih(i))
         enddo
      endif
      k=0
      do i=1,12
         if (iref(i).gt.0) then
            k=k+1
            box(i)=dfloat(ipar(k))/1000
         else
            box(i)=cel(i)
         endif
      enddo
      do i=10,12
         box(i)=box(i)*100
      enddo
      if (ninp.eq.0) then
         efirst=en
         print 83,en,(nint(1000*box(m)),m=1,9),
     +        (nint(box(m)),m=10,12),(itau(m),m=1,ndiha)
         write(16,83) en,(nint(1000*box(m)),m=1,9),
     +        (nint(box(m)),m=10,12),(itau(m),m=1,ndiha)
         if (toln.ge.0) then
            print 81
            write(16,81)
         else
            print*,' Only test for dihedral angles is performed'
            if (iprint.gt.0) print 80
         endif
      endif

C     Compare this structure with the experimental one
      ninp=ninp+1
      if (iprint.gt.2)
     +     print 35,geel,ninp,wit,(ipar(m),m=1,npar),(itau(m),m=1,ndiha)
      if (ifs.gt.9) then
         do i=1,ndiha
            d=abs(itau(i)-tauexp(i))
            if (d.gt.180) d=d-360
            if (abs(d).gt.dmax(i)) then
               if (iprint.gt.2) print*,itau(i),tauexp(i)
               goto 300
            endif
         enddo
      endif

      if (toln.lt.0) then
         nhit=nhit+1
         ihit(nhit)=inr
         if (iprint.gt.0)
     +        print 85,nhit,ninp,inr,en-efirst,(itau(m),m=1,ndiha)
         write(20,99)
     +        idummy,inr,en,(ipar(m),m=1,npar),(itau(m),m=1,ndiha)
         if (ifs.eq.0) inr=idummy
         goto 300
      endif

      do irot=1,nrot
         phi=box(10)/rad+irot*drot
         the=box(11)/rad
         psi=box(12)/rad
         ca=cos(phi)
         sa=sin(phi)
         cb=cos(the)
         sb=sin(the)
         cg=cos(psi)
         sg=sin(psi)
         rot1(1,1)= cg*ca-sg*sa*cb
         rot1(1,2)= cg*sa+sg*ca*cb
         rot1(1,3)= sg*sb
         rot1(2,1)=-sg*ca-cg*sa*cb
         rot1(2,2)=-sg*sa+cg*ca*cb
         rot1(2,3)= cg*sb
         rot1(3,1)= sa*sb
         rot1(3,2)=-ca*sb
         rot1(3,3)= cb
         call invbox(box,ainv)

         do isym=0,nsym
            do i=1,3
               do j=1,3
                  c=m123(isym)*msym(isym,j)
                  a1r1m(i,j)=0
                  do k=1,3
                     a1r1m(i,j)=a1r1m(i,j)+ainv(k,i)*rot1(k,j)*c
                  enddo
               enddo
            enddo
C           This is +/- A1(inv) R1 M
            box(7)=box(7)*m123(isym)
            box(8)=box(8)*m123(isym)
            box(9)=box(9)*m123(isym)

            call diff(box,boxexp,a1r1m,r2a2,iref,toln,iprint,
     +           ierr,difa,difb,boxtr,wrot)

            if (ierr.eq.1) then
               if (iprint.gt.1) print 92,ninp,irot,isym
               goto 390
            endif
            if (ierr.gt.1) then
               if (iprint.gt.1) print 91,ninp,irot,isym,ierr
               goto 390
            endif

C          Investigate possible transformation
            call matmat(euler,wrot,rot1)
            costh=euler(3,3)
            if (abs(costh).gt.1) costh=sign(1.0d0,costh)
            theta=acos(costh)
            if (abs(costh).le.0.99999) then
               psi=atan2(euler(1,3),euler(2,3))
               phi=atan2(euler(3,1),-euler(3,2))
            else
               phi=0
               psi=atan2(euler(1,2)*costh,euler(2,2)*costh)
C              This is arbitrary, only (PHI + PSI) is determinable
            endif
            if (phi.lt.-0.1) phi=phi+2*pi
            if (psi.lt.-0.1) psi=psi+2*pi
            boxtr(10)=phi*rad
            boxtr(11)=theta*rad
            boxtr(12)=psi*rad

C           Check whether differences are acceptable
            if (difb.gt.tolb) then
               if (iprint.gt.1) print 95,ninp,irot,isym,
     +              difa,difb,' too large'
               goto 390
            endif
            if (iprint.gt.1) print 95,ninp,irot,isym,
     +           difa,difb,' acceptable'

C           A hit was found!
            nhit=nhit+1
            ihit(nhit)=inr
            do m=1,12
               boxtr(m)=boxtr(m)-boxexp(m)
            enddo
            do m=10,12
               if (boxtr(m).gt. 180) boxtr(m)=boxtr(m)-360
               if (boxtr(m).lt.-180) boxtr(m)=boxtr(m)+360
            enddo
            do m=1,ndiha
               itau(m)=itau(m)-nint(tauexp(m))
               if (itau(m).gt. 180) itau(m)=itau(m)-360
               if (itau(m).lt.-180) itau(m)=itau(m)+360
            enddo
            print 84,nhit,ninp,inr,difa,difb,en-efirst,
     +           (nint(1000*boxtr(m)),m=1,9),
     +           (nint(boxtr(m)),m=10,12),(itau(m),m=1,ndiha)
            write(16,84) nhit,ninp,inr,difa,difb,en-efirst,
     +           (nint(1000*boxtr(m)),m=1,9),
     +           (nint(boxtr(m)),m=10,12),(itau(m),m=1,ndiha)
            write(20,99)
     +           idummy,inr,en,(ipar(m),m=1,npar),(itau(m),m=1,ndiha)
            if (ifs.eq.0) inr=idummy
            goto 300
  390       continue
         enddo
      enddo
      goto 300

C     Print data from original file
  400 continue
      idih1=100
      if (nhit.eq.0 .or. toln.lt.0 .or. iprint.eq.0) goto 500
      if (ifs.gt.9) then
         write(file0,16) 'pack.',20
         open(unit=11,file=file0,status='OLD',err=500)
      else
         write(file0,15) 'pack.',idih
         open(unit=11,file=file0,status='OLD',err=500)
      endif
      print*,' '
      print*,' Coming from data on file ',file0
  405 continue
      if (icode.eq.0) then
         read(11,*) idummy
         if (ifs.gt.9) then
            read(11,20) adummy
            read(11,20) adummy
            read(11,20) adummy
            read(11,20) adummy
         else
            read(11,*) j
            do i=1,j
               read(11,20) adummy
            enddo
            read(11,*) j
            do i=1,j
               read(11,20) adummy
            enddo
            read(11,20) adummy
            read(11,20) adummy
         endif
         goto 4222
      endif
      read(11,20) adummy
      read(11,*) j1,j2
      do i=1,j1+j2
         read(11,20) adummy
      enddo
      read(11,*) j
      do i=1,j
         read(11,20) adummy
      enddo
      read(11,20) adummy
      read(11,20) adummy
      read(11,20) adummy

 4222 continue
  430 read(11,20,end=450,err=450) adummy
      read(adummy,99) idummy,j
      do i=1,nhit
         if (ihit(i).eq.j) then
            ihit1(i)=idummy
            n=250
  435       continue
            if (adummy(n:n).eq.' ') then
               n=n-1
               goto 435
            endif
            print*,adummy(1:n)
         endif
      enddo
      goto 430
  450 close(11)
      if (ifs.lt.9) goto 500

      idih1=idih1+1
      write(file0,15) 'pack.',idih1
      open(unit=11,file=file0,status='OLD',err=500)
      if (idih1.eq.101) then
         print*,' '
         print*,' Coming from data on one of the following files:'
         do i=1,nhit
            ihit(i)=ihit1(i)
            do j=1,i-1
               if (ihit1(i).eq.ihit1(j)) ihit(i)=-1
            enddo
         enddo
      endif
      print*,'   file ',file0
      goto 405

  500 continue
      print*,ninp,' data read'
      print*,nhit,' hits found'
      write(16,*) ninp,' data read'
      write(16,*) nhit,' hits found'
      close(10)
      close(20)
      if (ifs.gt.9) then
         i=inpt('CHECK ',regel)
         stop
      endif
      goto 200
C     Go to the next conformation

  960 print*,' ***** No file IN.EXP present'
      stop
  980 print*,'No further files present'
      i=inpt('CHECK ',regel)
      stop

   12 format(a)
   13 format(a80)
   15 format(a5,i3.3)
   16 format(a5,i2.2)
   20 format(a250)
   21 format(' Input file:',i4)
   22 format(' Tolerances:',2f8.4,4x,2f8.1)
c 30   format(12f9.3)
   35 format(a,' Structure',i7,' read:    ',a,20i7)
c 40   format(a20,3f9.4)
   45 format(' File: ',a10)
   46 format('   Dihedral',i5,2x,3f8.2)
   72 format(i5,5x,a5,i5,6f8.4)
   80 format(7x,'Rank  Number Delta-E(kJ/mol)')
   81 format(7x,'Rank  Number Tol-N  Tol-R   Delta-E(kJ/mol)')
   82 format(' Experimental structure: ',16x,3i5,3(2x,3i4),2x,20i5)
   83 format(' First structure: ',14x,f8.1,1x,3i5,3(2x,3i4),2x,20i5)
   84 format(i4,2i7,2f7.3,f8.1,1x,3i5,3(2x,3i4),2x,20i5)
   85 format(i4,2i7,f8.1,2x,20i5)
   87 format(4i5,f10.3)
   91 format(6x,'Test',i8,4x,'Rotation',i3,4x,'Sym.op.',i3,
     +     '    No transformation possible, error condition',i4)
   92 format(6x,'Test',i8,4x,'Rotation',i3,4x,'Sym.op.',i3,
     +     '    No integer transformation matrix')
   93 format(6f10.4)
   94 format(12i5)
   95 format(6x,'Test',i8,4x,'Rotation',i3,4x,'Sym.op.',i3,
     +     '    Deviations',2f8.4,a15)
   99 format(2i7,f8.1,1x,25i5)
      end
